#package Packet ;

#####################################################################
#            Module pour la manipulation des paquets SIP            #
# AUTEUR : Guillaume Lehmann                                        #
# Pour tout renseignement, lehmann@free.fr                          #
# Ce logiciel est sous licence GPL v3 (http://www.gnu.org)          #
# v 0.1 du 18/10/2009                                               #
# v 0.2 du 05/03/2010                                               #
# v 0.3 du 07/05/2010                                               #
# v 0.4 du 09/05/2010                                               #
# v 0.5 du 15/05/2010                                               #
# v 0.6 du 18/05/2010                                               #
# v 0.7 du 21/05/2010                                               #
# v 0.8 du 30/05/2010                                               #
# v 0.9 du 01/06/2010                                               #
# v 0.10 du 04/06/2010                                              #
# v 0.11 du 13/06/2010                                              #
# v 0.12 du xx/xx/2010                                              #
# v 0.13 du xx/xx/2010                                              #
# v 0.14 du xx/xx/2010                                              #
# v 0.15 du xx/xx/2010                                              #
# v 0.16 du xx/xx/2010                                              #
# v 0.17 du xx/xx/2010                                              #
# v 0.18 du xx/xx/2010                                              #
# v 0.19 du xx/xx/2010                                              #
# v 0.20 du xx/xx/2010                                              #
#####################################################################



print '[Fonctions "Packet" inclues !]'."\n" ; 

#########################################
#                FUNCTIONS
# Packet_cut_Header()
# Packet_viaCompose()
# Packet_compoTagBranchNum()
# Packet_messageOK()
# Packet_messageRinging()
# Packet_messageTrying()
# Packet_messageACK()
# Packet_messageCANCEL()
# Packet_messageBYE()
# Packet_messageNOTIFY()
# Packet_messageREGISTER()
# Packet_messageINFO() (TODO)
# Packet_messageREFER()
# Packet_messageAccepted()
# Packet_message3xx()
# Packet_message4xx()
# Packet_message6xx()
#########################################



###########################################################################
# SIP message header dissection
# Args: ($messageFct)
#   $messageFct : SIP message to cut
# Returns: ($diversCompletFct, \%hProxy_AuthorizationFct, \%hCall_IDFct, \%hContactFct, $content_TypeFct, $content_LengthFct, \%hCSeqFct, \%hFromFct, \%hMax_ForwardsFct, $subscription_StateFct, \%hToFct, \@tabViaFct, \@tabRRouteFct, \@tabRouteFct, \%hLigneEtatFct, $corpsMessageFct) : all SIP message header fields.
# Comment:
#    None
###########################################################################
sub Packet_cutHeader {

    ##########################################################################################################################################
    # A la trononneuse je vais te le dcouper ce paquet moi ! Ligne par ligne et ensuite je t'y mets les bouts dans un tableau ! Mouahahaha !
    # Dcoupage du message.
    my $messageFct = $_[0] ;
    my $corpsMessageFct = '' ;
#    my $ligneEtatFct = '' ;

    my @tabMessageTotalFct ;
    my @tabEnTeteMessageFct ;
    my %hLigneEtatFct = () ;
    my @tabDiversFct ;
    my @tabViaFct ;
    my @tabRouteFct ;
    my @tabRRouteFct ;
    my %hAuthorizationFct = () ;
    my %hCall_IDFct = () ;
    my %hContactFct = () ;
    my %hCSeqFct = () ;
    my %hFromFct = () ;
    my %hToFct = () ;
    my %hMax_ForwardsFct = () ;
    my %hWWW_AuthenticateFct = () ;
    my %hProxy_AuthenticateFct = () ;
    my %hProxy_AuthorizatonFct = () ;
    my $content_TypeFct = '' ;
    my $erreurFct = "" ;

    @tabMessageTotalFct = split (/\r\n\r\n/, $messageFct) ;
    @tabEnTeteMessageFct = split (/\r\n/, $tabMessageTotalFct[0]) ;
    
    # Rcuprer le corps du message.
    $corpsMessageFct = $tabMessageTotalFct[1] ;

    # Rcuprer la ligne d'tat.
    # Si la ligne d'tat correspond  la regexp, alors c'est une requte, sinon c'est une rponse. On met les infos dans une table de hashage.
    # Voir paragraphes 7.1 (requtes) et 7.2 (rponse) de la RFC 3261.
    if (($hLigneEtatFct{'LigneEtat'}, $hLigneEtatFct{'Method'}, $hLigneEtatFct{'Request_URI'}) = $tabEnTeteMessageFct[0] =~ /((\w*)\s(sip:\S*)\sSIP\/2\.0)/) {
#	print "[DEBUG] Packet.pm, Le message SIP est une requte.\n" ;
    }
    elsif (($hLigneEtatFct{'LigneEtat'}, $hLigneEtatFct{'Status_code'}, $hLigneEtatFct{'Reason_phrase'}) = $tabEnTeteMessageFct[0] =~ /(SIP\/2\.0\s(\d*)\s(.*)?)/) {
#	print "[DEBUG] Packet.pm, Le message SIP est une rponse.\n" ;
    }
    else {
        # RFC 3261, 16.3.2
        $erreurFct = "416" ;
#	chop ($hLigneEtatFct{'LigneEtat'}) ;
    }


    # Traitement des arguments simples.
    # 8.2.2, RFC 3261 : If a UAS does not understand a header field in a request (that is, the header field is not defined in this specification or in any supported extension), the server MUST ignore that header field and continue processing the message. A UAS SHOULD ignore any malformed header fields that are not necessary for processing requests.
    if ((my $acceptFct) = $tabMessageTotalFct[0] =~ /(Accept:\s*.*)\r\n/) {
 	# chomp ($acceptFct) ;
 	unshift(@tabDiversFct, $acceptFct) ;
    }
    if ((my $accept_EncodingFct) = $tabMessageTotalFct[0] =~ /(Accept-Encoding:\s*.*)\r\n/) {
 	# chomp ($accept_EncodingFct) ;
 	unshift(@tabDiversFct, $accept_EncodingFct) ;
    }
    if ((my $accept_LanguageFct) = $tabMessageTotalFct[0] =~ /(Accept-Language:\s*.*)\r\n/) {
 	# chomp ($accept_LanguageFct) ;
 	unshift(@tabDiversFct, $accept_LanguageFct) ;
    }
    if ((my $alert_InfoFct) = $tabMessageTotalFct[0] =~ /(Alert-Info:\s*.*)\r\n/) {
 	# chomp ($alert_InfoFct) ;
 	unshift(@tabDiversFct, $alert_InfoFct) ;
    }
    if ((my $allowFct) = $tabMessageTotalFct[0] =~ /(Allow:\s*.*)\r\n/) {
 	# chomp($allowFct) ;
 	unshift(@tabDiversFct, $allowFct) ;
    }
    #    if ((my $alsoFct) = $tabMessageTotalFct[0] =~ /(Also:\s*.*)/) {
    #	chop ($alsoFct) ;
    #	unshift(@tabDiversFct, $alsoFct) ;
    #    }
    if ((my $authentication_InfoFct) = $tabMessageTotalFct[0] =~ /(Authentication-Info:\s*.*)\r\n/) {
 	# chomp ($authentication_InfoFct) ;
 	unshift(@tabDiversFct, $authentication_InfoFct) ;
    }
    # Paragraphe 20.44 et 22.2 de la RFC 3261
    if (($hAuthorizationFct{'Authorization'}) = $tabMessageTotalFct[0] =~ /(Authorization:\s*.*)\r\n/) {
	# chomp ($hAuthorizationFct{'Authorization'}) ;
	($hAuthorizationFct{'cnonce'}) = $hAuthorizationFct{'Authorization'} =~ /cnonce=\W?(\w*)/ ;
	($hAuthorizationFct{'realm'}) = $hAuthorizationFct{'Authorization'} =~ /realm=\W?(\S*)\"/ ;
	($hAuthorizationFct{'uri'}) = $hAuthorizationFct{'Authorization'} =~ /uri=\W?(sip:\S*)\"/ ;
	($hAuthorizationFct{'qop'}) = $hAuthorizationFct{'Authorization'} =~ /qop=\W?(\w*)/ ;
	($hAuthorizationFct{'username'}) = $hAuthorizationFct{'Authorization'} =~ /username=\W?(\w*)/ ;
	($hAuthorizationFct{'nc'}) = $hAuthorizationFct{'Authorization'} =~ /nc=\W?(\w*)/ ;
	($hAuthorizationFct{'opaque'}) = $hAuthorizationFct{'Authorization'} =~ /opaque=\W?(\w*)/ ;
	($hAuthorizationFct{'nonce'}) = $hAuthorizationFct{'Authorization'} =~ /\Wnonce=\W?(\w*)/ ;
	($hAuthorizationFct{'response'}) = $hAuthorizationFct{'Authorization'} =~ /response=\W?(\w*)/ ;
    }
    ($hCall_IDFct{'Call_ID'}, $hCall_IDFct{'Call_ID_ID'}) = $tabMessageTotalFct[0] =~ /(Call-ID:\s*(.*))\r\n/ ;
    # chomp($hCall_IDFct{'Call_ID'}) ;
    if ((my $call_InfoFct) = $tabMessageTotalFct[0] =~ /(Call-Info:\s*.*)\r\n/) {
 	# chomp ($call_InfoFct) ;
 	unshift(@tabDiversFct, $call_InfoFct) ;
    }
    #    # CC-Diversion
    #    if ((my $diversionFct, $diversion_Num, $diversion_Adr, $diversion_reason) = $tabMessageTotalFct[0] =~ /(Diversion:\s*<sip:(\d*)\@(.*)>;reason=(\w*).*)/) {
    #	chop($diversionFct) ;
    #	unshift(@tabDiversFct, $diversionFct) ;
    #    }
    if (($hContactFct{'Contact'}) = $tabMessageTotalFct[0] =~ /(Contact:\s*[\*|.*])\r\n/) {
 	# chomp($hContactFct{'Contact'}) ;
 	if ($hLigneEtatFct !~ /REGISTER/){ # Mettre la variable dans le tableau si on n'est pas dans un REGISTER
 	    unshift(@tabDiversFct, $hContactFct{'Contact'}) ;
 	}
    }
    elsif (($hContactFct{'Contact'}, $hContactFct{'Contact_Num'}, $hContactFct{'Contact_Adr'}) = $tabMessageTotalFct[0] =~ /(Contact:\s*(?:\*|<sip:(\d*)\@(\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}).*>).*)\r\n/) {
 	# chomp($hContactFct{'Contact'}) ;
 	if ($hLigneEtatFct !~ /REGISTER/){ # Mettre la variable dans le tableau si on n'est pas dans un REGISTER
 	    unshift(@tabDiversFct, $hContactFct{'Contact'}) ;
 	}
    }
    if ((my $content_DispositionFct) = $tabMessageTotalFct[0] =~ /(Content-Disposition:\s*.*)\r\n/) {
 	# chomp ($content_DispositionFct) ;
 	unshift(@tabDiversFct, $content_DispositionFct) ;
    }
    if ((my $content_EncodingFct) = $tabMessageTotalFct[0] =~ /(Content-Encoding:\s*.*)\r\n/) {
 	# chomp ($content_EncodingFct) ;
 	unshift(@tabDiversFct, $content_EncodingFct) ;
    }
    if ((my $content_LanguageFct) = $tabMessageTotalFct[0] =~ /(Content-Language:\s*.*)\r\n/) {
 	# chomp ($content_LanguageFct) ;
 	unshift(@tabDiversFct, $content_LanguageFct) ;
    }
    (my $content_LengthFct) = $tabMessageTotalFct[0] =~ /(Content-Length:\s*\d*)/ ; # # chomp() inutile pour lui car on a ensuite une ligne vide dans le message.
#    if (($content_TypeFct) = $tabMessageTotalFct[0] =~ /(Content-Type:\s*.*)/) {
# 	chop($content_TypeFct) ;
#    }
    if (($content_TypeFct) = $tabMessageTotalFct[0] =~ /(Content-Type:\s*.*)\r\n/) {
 	# chomp ($content_TypeFct) ;
# 	unshift(@tabDiversFct, $Content_Type) ;
    }
    ($hCSeqFct{'CSeq'}, $hCSeqFct{'CSeq_Num'}, $hCSeqFct{'CSeq_Type'}) = $tabMessageTotalFct[0] =~ /(CSeq:\s*(\d*)\s(.*))\r\n/ ;
    # chomp($hCSeqFct{'CSeq'}) ;
    # chomp ($hCSeqFct{'CSeq_Type'}) ;
    if ((my $dateFct) = $tabMessageTotalFct[0] =~ /(Date:\s*.*)\r\n/) {
 	# chomp($dateFct) ;
 	unshift(@tabDiversFct, $dateFct) ;
    }
    #    if ((my $encryptionFct) = $tabMessageTotalFct[0] =~ /(Encryption:\s*.*)/) {
    #	chop($encryptionFct) ;
    #	unshift(@tabDiversFct, $encryptionFct) ;
    #    }
    if ((my $error_InfoFct) = $tabMessageTotalFct[0] =~ /(Error-Info:\s*.*)\r\n/) {
 	# chomp($error_InfoFct) ;
 	unshift(@tabDiversFct, $error_InfoFct) ;
    }
    if ((my $eventFct) = $tabMessageTotalFct[0] =~ /(Event:\s*.*)\r\n/) {
 	# chomp($eventFct) ;
 	unshift(@tabDiversFct, $eventFct)
 	}
#   if ((my $ExpiresFct, $Expires_ValeurFct) = $tabMessageTotalFct[0] =~ /(Expires:\s*(\d*).*)/) {
    if ((my $expiresFct) = $tabMessageTotalFct[0] =~ /(Expires:\s*.*)\r\n/) {
 	# chomp($expiresFct) ;
 	unshift(@tabDiversFct, $expiresFct) ;
    }
    ($hFromFct{'From'}, $hFromFct{'From_Num'}, $hFromFct{'From_AdrIP'}, $hFromFct{'From_Port'}, $hFromFct{'From_Info'}, $hFromFct{'From_Options'}) = $tabMessageTotalFct[0] =~ /(From:.*<sip:(.*)\@(\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}|\D*)(?::(\d*)|)(?:;(.*)|)*>(?:;(.*)|)*.*)\r\n/ ;

    # To avoid a bug in the CSIPSimple application (Archos 5IT).
    if (! $hFromFct{'From'}) {
	($hFromFct{'From'}, $hFromFct{'From_Num'}, $hFromFct{'From_AdrIP'}, $hFromFct{'From_Port'}, $hFromFct{'From_Info'}, $hFromFct{'From_Options'}) = $tabMessageTotalFct[0] =~ /(From:.*sip:(.*)\@(\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}|\D*).*)\r\n/ ;
    }
    # chomp($hFromFct{'From'}) ;
    if ((my $in_Reply_ToFct) = $tabMessageTotalFct[0] =~ /(In-Reply-To:\s*.*)\r\n/) {
 	# chomp($in_Reply_ToFct) ;
 	unshift(@tabDiversFct, $in_Reply_ToFct) ;
    }
    if (($hMax_ForwardsFct{'Max_Forwards'}, $hMax_ForwardsFct{'Max_Forwards_Valeur'}) = $tabMessageTotalFct[0] =~ /(Max-Forwards:\s*(\d*).*)\r\n/) {
 	# chomp($hMax_ForwardsFct{'Max_Forwards'}) ;
        # RFC 3261, 16.3.3
        if ($hMax_ForwardsFct{'Max_Forwards'} <= 0) {
	    $erreurFct = "483" ;
	}
    }
    if ((my $min_ExpiresFct) = $tabMessageTotalFct[0] =~ /(Min-Expires:\s*.*)\r\n/) {
 	# chomp($min_ExpiresFct) ;
 	unshift(@tabDiversFct, $min_ExpiresFct) ;
    }
    if ((my $mIME_VersionFct) = $tabMessageTotalFct[0] =~ /(MIME-Version:\s*.*)\r\n/) {
 	# chomp($mIME_VersionFct) ;
 	unshift(@tabDiversFct, $mIME_VersionFct) ;
    }
    #    if ((my $min_SEFct) = $tabMessageTotalFct[0] =~ /(Min_SE:\s*.*)/) {
    #	chop($min_SEFct) ;
    #	unshift(@tabDiversFct, $min_SEFct) ;
    #    }
    if ((my $organizationFct) = $tabMessageTotalFct[0] =~ /(Organization:\s*.*)\r\n/) {
 	# chomp($organizationFct) ;
 	unshift(@tabDiversFct, $organizationFct) ;
    }
    if ((my $priorityFct) = $tabMessageTotalFct[0] =~ /(Priority:\s*.*)\r\n/) {
 	# chomp($priorityFct) ;
 	unshift(@tabDiversFct, $priorityFct) ;
    }
    if (($hProxy_AuthenticateFct{'Proxy_Authenticate'}) = $tabMessageTotalFct[0] =~ /(Proxy-Authenticate:\s*.*)\r\n/) {
 	# chomp($hProxy_AuthenticateFct) ;	
	($hProxy_AuthenticateFct{'cnonce'}) = $hProxy_AuthenticateFct{'Proxy_Authenticate'} =~ /cnonce=\W?([^\s|^\"]*)/ ;
	($hProxy_AuthenticateFct{'realm'}) = $hProxy_AuthenticateFct{'Proxy_Authenticate'} =~ /realm=\W?([^\s|^\"]*)/ ;
	($hProxy_AuthenticateFct{'uri'}) = $hProxy_AuthenticateFct{'Proxy_Authenticate'} =~ /uri=\W?(sip:[^\s|^\"]*)/ ;
	($hProxy_AuthenticateFct{'qop'}) = $hProxy_AuthenticateFct{'Proxy_Authenticate'} =~ /qop=\W?(auth)/ ;
	($hProxy_AuthenticateFct{'username'}) = $hProxy_AuthenticateFct{'Proxy_Authenticate'} =~ /username=\W?([^\s|^\"]*)/ ;
	($hProxy_AuthenticateFct{'nc'}) = $hProxy_AuthenticateFct{'Proxy_Authenticate'} =~ /nc=\W?(\d*)/ ;
	($hProxy_AuthenticateFct{'opaque'}) = $hProxy_AuthenticateFct{'Proxy_Authenticate'} =~ /opaque=\W?([^\s|^\"]*)/ ;
	($hProxy_AuthenticateFct{'nonce'}) = $hProxy_AuthenticateFct{'Proxy_Authenticate'} =~ /\Wnonce=\W?([^\s|^\"]*)/ ;
	($hProxy_AuthenticateFct{'response'}) = $hProxy_AuthenticateFct{'Proxy_Authenticate'} =~ /response=\W?([^\s|^\"]*)/ ;
	# unshift(@tabDiversFct, $hproxy_AuthenticateFct) ;
    }
    if (($hProxy_AuthorizationFct{'Proxy_Authorization'}) = $tabMessageTotalFct[0] =~ /(Proxy-Authorization:\s*.*)\r\n/) {
 	# chomp($hProxy_AuthorizationFct) ;

	($hProxy_AuthorizationFct{'cnonce'}) = $hProxy_AuthorizationFct{'Proxy_Authorization'} =~ /cnonce=\W?([^\s|^\"]*)/ ;
	($hProxy_AuthorizationFct{'realm'}) = $hProxy_AuthorizationFct{'Proxy_Authorization'} =~ /realm=\W?([^\s|^\"]*)/ ;
	($hProxy_AuthorizationFct{'uri'}) = $hProxy_AuthorizationFct{'Proxy_Authorization'} =~ /uri=\W?(sip:[^\s|^\"]*)/ ;
	($hProxy_AuthorizationFct{'qop'}) = $hProxy_AuthorizationFct{'Proxy_Authorization'} =~ /qop=\W?(auth)/ ;
	($hProxy_AuthorizationFct{'username'}) = $hProxy_AuthorizationFct{'Proxy_Authorization'} =~ /username=\W?([^\s|^\"]*)/ ;
	($hProxy_AuthorizationFct{'nc'}) = $hProxy_AuthorizationFct{'Proxy_Authorization'} =~ /nc=\W?(\d*)/ ;
	($hProxy_AuthorizationFct{'opaque'}) = $hProxy_AuthorizationFct{'Proxy_Authorization'} =~ /opaque=\W?([^\s|^\"]*)/ ;
	($hProxy_AuthorizationFct{'nonce'}) = $hProxy_AuthorizationFct{'Proxy_Authorization'} =~ /\Wnonce=\W?([^\s|^\"]*)/ ;
	($hProxy_AuthorizationFct{'response'}) = $hProxy_AuthorizationFct{'Proxy_Authorization'} =~ /response=\W?(\w*)/ ;
	#unshift(@tabDiversFct, $proxy_AuthorizationFct) ;
    }
    if ((my $proxy_RequireFct) = $tabMessageTotalFct[0] =~ /(Proxy-Require:\s*.*)\r\n/) {
 	# chomp($proxy_RequireFct) ;
 	unshift(@tabDiversFct, $proxy_RequireFct) ;
    }
    #    if ((my $rackFct) = $tabMessageTotalFct[0] =~ /(Rack:\s*.*)/) {
    #	chop($rackFct) ;
    #	unshift(@tabDiversFct, $rackFct) ;
    #    }
    if ((my $reply_ToFct) = $tabMessageTotalFct[0] =~ /(Reply-To:\s*.*)\r\n/) {
 	# chomp($reply_ToFct) ;
 	unshift(@tabDiversFct, $reply_ToFct) ;
    }
    if ((my $reasonFct) = $tabMessageTotalFct[0] =~ /(Reason:\s*.*)\r\n/) {
 	# chomp($reasonFct) ;
 	unshift(@tabDiversFct, $reasonFct) ;
    }
    if ((my $referred_ByFct) = $tabMessageTotalFct[0] =~ /(Referred-By:\s*.*)\r\n/) {
 	# chomp($referred_ByFct) ;
 	unshift(@tabDiversFct, $referred_ByFct) ;
    }
    if ((my $referred_ToFct) = $tabMessageTotalFct[0] =~ /(Referred-To:\s*.*)\r\n/) {
 	# chomp($referred_ToFct) ;
 	unshift(@tabDiversFct, $referred_ToFct) ;
    }
    if ((my $refer_ToFct) = $tabMessageTotalFct[0] =~ /(Refer-To:\s*.*)\r\n/) {
 	# chomp($refer_ToFct) ;
 	unshift(@tabDiversFct, $refer_ToFct) ;
    }
    if ((my $replacesFct) = $tabMessageTotalFct[0] =~ /(Replaces:\s*.*)\r\n/) {
 	# chomp($replacesFct) ;
 	unshift(@tabDiversFct, $replacesFct) ;
    }
    if ((my $requested_ByFct) = $tabMessageTotalFct[0] =~ /(Requested-By:\s*.*)\r\n/) {
 	# chomp($requested_ByFct) ;
 	unshift(@tabDiversFct, $requested_ByFct) ;
    }
    if ((my $requireFct) = $tabMessageTotalFct[0] =~ /(Require:\s*.*)\r\n/) {
 	# chomp($requireFct) ;
 	unshift(@tabDiversFct, $requireFct) ;
    }
    #    if ((my $response_KeyFct) = $tabMessageTotalFct[0] =~ /(Response-Key:\s*.*)/) {
    #	chop($response_KeyFct) ;
    #	unshift(@tabDiversFct, $response_KeyFct) ;
    #    }
    if ((my $retry_AfterFct) = $tabMessageTotalFct[0] =~ /(Retry-After:\s*.*)\r\n/) {
 	# chomp($retry_AfterFct) ;
 	unshift(@tabDiversFct, $retry_AfterFct) ;
    }
    #    if ((my $rSeqFct) = $tabMessageTotalFct[0] =~ /(RSeq:\s*.*)/) {
    #	chop($rSeqFct) ;
    #	unshift(@tabDiversFct, $rSeqFct) ;
    #    }
    if ((my $serverFct) = $tabMessageTotalFct[0] =~ /(Server:\s*.*)\r\n/) {
 	# chomp($serverFct) ;
 	unshift(@tabDiversFct, $serverFct) ;
    }
    #    if ((my $session_ExpiresFct) = $tabMessageTotalFct[0] =~ /(Session-Expires:\s*.*)/) {
    #	chop($session_ExpiresFct) ;
    #	unshift(@tabDiversFct, $session_ExpiresFct) ;
    #    }
    if ((my $subjectFct) = $tabMessageTotalFct[0] =~ /(Subject:\s*.*)\r\n/) {
	# chomp($subjectFct) ;
 	unshift(@tabDiversFct, $subjectFct) ;
    }
    (my $subscription_StateFct) = $tabMessageTotalFct[0] =~ /(Subscription-State:\s*.*)\r\n/ ;
    # chomp($subscription_StateFct) ;
    if ((my $supportedFct) = $tabMessageTotalFct[0] =~ /(Supported:\s*.*)\r\n/) {
 	# chomp($supportedFct) ;
 	unshift(@tabDiversFct, $supportedFct) ;
    }
    if ((my $timestampFct) = $tabMessageTotalFct[0] =~ /(Timestamp:\s*.*)\r\n/) {
	# chomp($timestampFct) ;
	unshift(@tabDiversFct, $timestampFct) ;
    }
    # 8.2.2.1, RFC 3261 : [...] it is RECOMMENDED that a UAS accept requests even if they do not recognize the URI scheme (for example, a tel: URI) in the To header field [...]
    ($hToFct{'To'}, $hToFct{'To_Num'}, $hToFct{'To_AdrIP'}, $hToFct{'To_Port'}, $hToFct{'To_Info'}, $hToFct{'To_Options'}) = $tabMessageTotalFct[0] =~ /(To:.*<sip:(.*)\@(\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}|\D*)(?::(\d*)|)(?:;(.*)|)*>(?:;(.*)|)*.*)\r\n/ ;

    # To avoid a bug in the CSIPSimple application (Archos 5IT).
    if (! $hToFct{'To'}) {
	($hToFct{'To'}, $hToFct{'To_Num'}, $hToFct{'To_AdrIP'}, $hToFct{'To_Port'}, $hToFct{'To_Info'}, $hToFct{'To_Options'}) = $tabMessageTotalFct[0] =~ /(To:.*sip:(.*)\@(\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}|\D*).*)\r\n/ ;
    }
    # chomp($hToFct{'To'}) ;
    if ((my $unsupportedFct) = $tabMessageTotalFct[0] =~ /(Unsupported:\s*.*)\r\n/) {
	# chomp($unsupportedFct) ;
	unshift(@tabDiversFct, $unsupportedFct) ;
    }
    if ((my $user_AgentFct) = $tabMessageTotalFct[0] =~ /(User-Agent:\s*.*)\r\n/) {
	# chomp($user_AgentFct) ;
	unshift(@tabDiversFct, $user_AgentFct) ;
    }
    if ((my $warningFct) = $tabMessageTotalFct[0] =~ /(Warning:\s*.*)\r\n/) {
	# chomp($warningFct) ;
	unshift(@tabDiversFct, $warningFct) ;
    }
    if (($hWWW_AuthenticateFct{'WWW_Authenticate'}) = $tabMessageTotalFct[0] =~ /(WWW-Authenticate:\s*.*)\r\n/) {
	# chomp($hWWW_AuthenticateFct{'WWW_Authenticate'}) ;
	($hWWW_AuthenticateFct{'realm'}) = $hWWW_AuthenticateFct{'WWW_Authenticate'} =~ /realm=\W?(\S*)\"/ ;
	($hWWW_AuthenticateFct{'qop'}) = $hWWW_AuthenticateFct{'WWW_Authenticate'} =~ /qop=\W?(\w*)/ ;
	($hWWW_AuthenticateFct{'opaque'}) = $hWWW_AuthenticateFct{'WWW_Authenticate'} =~ /opaque=\W?(\w*)/ ;
	($hWWW_AuthenticateFct{'nonce'}) = $hWWW_AuthenticateFct{'WWW_Authenticate'} =~ /\Wnonce=\W?(\w*)/ ;
	($hWWW_AuthenticateFct{'stale'}) = $hWWW_AuthenticateFct{'WWW_Authenticate'} =~ /stale=\W?(\w*)/ ;
	($hWWW_AuthenticateFct{'algorithm'}) = $hWWW_AuthenticateFct{'WWW_Authenticate'} =~ /algorithm=\W?(\w*)/ ;
#	unshift(@tabDiversFct, $hWWW_AuthenticateFct) ;
    }
    
    # Traitement des arguments qui peuvent tre en liste : parcourir les lignes de l'en-tte pour rcuprer les champs
    for (my $compteurFct = 0; $tabEnTeteMessageFct[$compteurFct] ne ''; $compteurFct ++ ) {
	# les Via: et les mettre dans un tableau.
	if ($tabEnTeteMessageFct[$compteurFct] =~ /^Via:.*/) {
	    push (@tabViaFct, $tabEnTeteMessageFct[$compteurFct]) ;
	}
	# les Record-Route: et les mettre dans un tableau.
	elsif ($tabEnTeteMessageFct[$compteurFct] =~ /^Record\-Route:.*/) {
	    push (@tabRRouteFct, $tabEnTeteMessageFct[$compteurFct]) ;
	}
	# les Route:  et les mettre dans un tableau.
	elsif ($tabEnTeteMessageFct[$compteurFct] =~ /^Route:.*/) {
	    push (@tabRouteFct, $tabEnTeteMessageFct[$compteurFct]) ;
	}
    }
    

    # On assemble tout le contenu du @tabDiversFct dans une variable avec \r\n entre chaque valeur.
    my $diversCompletFct = join("\r\n", @tabDiversFct) ;
    ##########################################################################################################################################


    return ($diversCompletFct, \%hProxy_AuthorizationFct, \%hCall_IDFct, \%hContactFct, $content_TypeFct, $content_LengthFct, \%hCSeqFct, \%hFromFct, \%hMax_ForwardsFct, $subscription_StateFct, \%hToFct, \@tabViaFct, \@tabRRouteFct, \@tabRouteFct, \%hLigneEtatFct, $corpsMessageFct) ;
}


###########################################################################
# Compose the Via: field
# Args: ($option0Fct, $refTabViaFct, $addressPeerFct, $portPeerFct)
#   $option0Fct : indicate what manipulation to do
#   $refTabViaFct : the Via: paragraph
#   $addressPeerFct : peer address
#   $portPeerFct : peer port
# Returns: $tabViaComposedFct : the new Via: paragraph
# Comment:
#    None
###########################################################################
sub Packet_viaCompose {

    my $option0Fct = $_[0] ;
    my $refTabViaFct = $_[1] ;
    my $addressPeerFct = $_[2] ;
    my $portPeerFct = $_[3] ;
    my $branchFct = $_[4] ;
    my $tabViaComposedFct = '' ;

    
    my @tabViaFct = @$refTabViaFct ;

    # On enlve le "rport" tout seul (bug de certaines piles SIP).
#    $tabViaFct[0] =~ s/rport;// ;

    # We keep all Via: fields. If we have the informations, we add received= on the top Via: field.
    if ($addressPeerFct and $portPeerFct) {
	$tabViaFct[0] = $tabViaFct[0].";received=$addressPeerFct;rport=$portPeerFct" ;
    }
    
    # If "ajout" option is set, we insert the proxy SIP address and port in a new Via: field.
    if ($option0Fct eq 'ajout') {
#	(my $brancheFct) = $tabViaFct[0] =~ /branch=([^;]*)/ ;
	my $brancheFct = &Packet_compoTagBranchNum('b') ;
	unshift(@tabViaFct, "Via: SIP/2.0/UDP $ADRESSESRV;branch=$brancheFct") ;
    }

    # If "crea" option is set, we create un Via: field with the proxy SIP address and port.
    elsif ($option0Fct eq 'crea') {
	if (! $branchFct) {
	    $branchFct = &Packet_compoTagBranchNum("b") ;
	}
	$tabViaFct[0] = "Via: SIP/2.0/UDP $ADRESSESRV:$PORT;branch=$branchFct" ;
    }
    
    # If the "suppr" option is set, we delete the top Via: field.
    elsif ($option0Fct eq 'suppr') {
	shift(@tabViaFct) ;
    }
    
    # If "rec" option is set, we do nothing more (a received= information was added).
    elsif ($option0Fct eq 'rec') {        
    }
    
    $tabViaComposedFct = join ("\r\n", @tabViaFct) ;
    
    return ($tabViaComposedFct) ;
}


###########################################################################
# Compose a new branch or a new tag or a random number
# Args: ($_[0])
#   $_[0] : what action to do (n = number, b = branch, default is a tag)
# Returns: $tagBranchNewFct
# Comment:
#    None
###########################################################################
sub Packet_compoTagBranchNum {

    my $tagBranchNewFct = '' ;
    my $chaineCaract = $CHAINETAGBRANCH ;
    # To build a number, we change the string composition from which we extract the elements.
    if ($_[0] eq 'n') {
	$chaineCaract = '0123456789' ;
    }
    # If we want a number for un branch (so begining bye z9hG4bk), then we set "b" as argument, else we set "t" for a tag.
    if ($_[0] eq 'b') {
	$tagBranchNewFct = 'z9hG4bk' ;
    }
    # We execute the element extract from the string, 10 times to have a 10 caract. string.
    for (my $compteurFct = 1; $compteurFct <= 10; $compteurFct ++) {
	# We choose randomly (rand) a single number between 0 and the length string (length()). This number indicate the element extracted position (substr()) from the string (CHAINETAGBRANCH). We concatenate this character to what is ever been calculated by previous "for" round.
	$tagBranchNewFct = $tagBranchNewFct.substr($chaineCaract, rand (length($chaineCaract)), 1) ;
    }
    return $tagBranchNewFct ;
}


###########################################################################
# Compose the OK response to send or to forward.
# Args: ($optionFct, $strctSIPFct, $serverPeerHostFct, $serverPeerPortFct)
#   $optionFct : Indicate if the OK message is created before being
#                send ("send") or just modifiy before being
#                forwarded ("forward").
#   $strctSIPFct : SIP header information in a structure.
#   $serverPeerHostFct : The peer host address which send the OK.
#   $serverPeerPortFct : The peer host port which send the OK.
# Returns: $messageOKFct : The OK message to send.
# Comment:
#    None
###########################################################################
sub Packet_messageOK {

    print "[DEBUG] Packet.pm, Enter in the messageOK function\n" ;
    
    my $optionFct = $_[0] ;
    my $strctSIPFct = $_[1] ;
    my $serverPeerHostFct = $_[2] ;
    my $serverPeerPortFct = $_[3] ;
    my $messageOKFct = '' ;

    # Here the code called when we need to forward a OK response.
    if ($optionFct eq 'forward') {
	# We need to distinguish a response to INVITE than a response to BYE or NOTIFY.
	if ($strctSIPFct->HCSeq->{'CSeq'} =~ /INVITE/) {
	    my $paraViaFct = &Packet_viaCompose('suppr', $strctSIPFct->TabVia, 0, 0) ;
	    # Compose Record-Route : we add the proxy SIP address (if it not yet be). Then, it will be on the way.
	    if (grep(/$ADRESSESRV/, @{$strctSIPFct->TabRRoute}) == 0) {
		unshift(@{$strctSIPFct->TabRRoute}, "Record-Route: <sip:$ADRESSESRV;lr>") ;
	    }
	    my $paraRRouteFct = join("\r\n", @{$strctSIPFct->TabRRoute}) ;
	    # Message composition.
	    $messageOKFct = "SIP/2.0 200 OK\r
$paraViaFct\r
".$strctSIPFct->HFrom->{'From'}."\r
".$strctSIPFct->HTo->{'To'}."\r
".$strctSIPFct->HCall_ID->{'Call_ID'}."\r
$paraRRouteFct\r
".$strctSIPFct->HCSeq->{'CSeq'}."\r
".$strctSIPFct->DiversComplet."\r
".$strctSIPFct->Content_Type."\r
".$strctSIPFct->Content_Length."\r\n" ;
#\r
#".$strctSIPFct->CorpsMessage ;
	}
	else {
	    # OK sended and need to be forwarded to response to a BYE or NOTIFY message.
	    my $paraViaFct = &Packet_viaCompose('suppr', $strctSIPFct->TabVia, 0, 0) ;
	    # Message composition.
	    $messageOKFct = "SIP/2.0 200 OK\r
$paraViaFct\r
".$strctSIPFct->HFrom->{'From'}."\r
".$strctSIPFct->HTo->{'To'}."\r
".$strctSIPFct->HCall_ID->{'Call_ID'}."\r
".$strctSIPFct->HCSeq->{'CSeq'}."\r
".$strctSIPFct->DiversComplet."\r
Content-Length: 0\r\n" ;
	}
    }
    elsif ($optionFct eq 'send') {
	# OK to response to a REGISTER or SUBSCRIBE or CANCEL or INFO message.
	my $paraViaFct = &Packet_viaCompose('rec', $strctSIPFct->TabVia, $serverPeerHostFct, $serverPeerPortFct) ;
	# Message composition.
	$messageOKFct = "SIP/2.0 200 OK\r
$paraViaFct\r
".$strctSIPFct->HFrom->{'From'}."\r
".$strctSIPFct->HTo->{'To'}."\r
".$strctSIPFct->HCall_ID->{'Call_ID'}."\r
".$strctSIPFct->HCSeq->{'CSeq'}."\r
".$strctSIPFct->HContact->{'Contact'}."\r
".$strctSIPFct->Content_Length."\r\n" ;
    }

    $messageOKFct =~ s/\r\n\r\n/\r\n/g ;
    if ($strctSIPFct->CorpsMessage) {
	$messageOKFct = $messageOKFct."\r\n".$strctSIPFct->CorpsMessage ;
    }
    else {
	$messageOKFct = $messageOKFct."\r\n" ;
    }
    
    return($messageOKFct) ;
}


###########################################################################
# Compose the Accepted response to send or to forward.
# Args: ($optionFct, $strctSIPFct, $serverPeerHostFct, $serverPeerPortFct)
#   $optionFct : Indicate if the Accepted message is created before being
#                send ("send") or just modifiy before being
#                forwarded ("forward").
#   $strctSIPFct : SIP header information in a structure.
#   $serverPeerHostFct : The peer host address which send the Accepted.
#   $serverPeerPortFct : The peer host port which send the Accepted.
# Returns: $messageAcceptedFct : The Accepted message to send.
# Comment:
#    None
###########################################################################
sub Packet_messageAccepted {

    print "[DEBUG] Packet.pm, Enter in the messageAccepted function\n" ;
    
    my $optionFct = $_[0] ;
    my $strctSIPFct = $_[1] ;
    my $serverPeerHostFct = $_[2] ;
    my $serverPeerPortFct = $_[3] ;
    my $messageAcceptedFct = '' ;

    if ($optionFct eq 'forward') {
	# Via: field composition.
	my $paraViaFct = &Packet_viaCompose('suppr', $strctSIPFct->TabVia, 0, 0) ;
	# Message composition.
	$messageAcceptedFct = "SIP/2.0 202 Accepted\r
$paraViaFct\r
".$strctSIPFct->HFrom->{'From'}."\r
".$strctSIPFct->HTo->{'To'}."\r
".$strctSIPFct->HCall_ID->{'Call_ID'}."\r
".$strctSIPFct->HCSeq->{'CSeq'}."\r
".$strctSIPFct->DiversComplet."\r
Content-Length: 0\r\n" ;
    }

    $messageAcceptedFct =~ s/\r\n\r\n/\r\n/g ;
    $messageAcceptedFct = $messageAcceptedFct."\r\n" ;

    return($messageAcceptedFct) ;
}


###########################################################################
# Compose the Ringing response to send or to forward.
# Args: ($optionFct, $strctSIPFct, $serverPeerHostFct, $serverPeerPortFct)
#   $optionFct : Indicate if the Ringing message is created before being
#                send ("send") or just modifiy before being
#                forwarded ("forward").
#   $strctSIPFct : SIP header information in a structure.
#   $serverPeerHostFct : The peer host address which send the Ringing.
#   $serverPeerPortFct : The peer host port which send the Ringing.
# Returns: $messageRingingFct : The Ringing message to send.
# Comment:
#    None
###########################################################################
sub Packet_messageRinging {
# 21.1, RFC 3261 : Provisional 1xx. A server sends a 1xx response if it expects to take more than 200 ms to obtain a final response. Note that 1xx responses are not transmitted reliably. They never cause the client to send an ACK. Provisional (1xx) responses MAY contain message bodies, including session descriptions.

    print "[DEBUG] Packet.pm, Enter in the messageRinging function\n" ;
    
    my $optionFct = $_[0] ;
    my $strctSIPFct = $_[1] ;
    my $serverPeerHostFct = $_[2] ;
    my $serverPeerPortFct = $_[3] ;
    my $messageRingingFct = '' ;

    # Here the code called when we need to forward a Ringing response.
    if ($optionFct eq 'forward') {
	# We compose the Via: field : we keep all Via: unless the first.
	my $paraViaFct = &Packet_viaCompose('suppr', $strctSIPFct->TabVia, 0, 0) ;
	# We compose the Record-Route: field : we keep them all.
	my $paraRRouteFct = join("\r\n", @{$strctSIPFct->TabRRoute}) ;
	# Message composition.
	$messageRingingFct = "SIP/2.0 180 Ringing\r
$paraViaFct\r
".$strctSIPFct->HFrom->{'From'}."\r
".$strctSIPFct->HTo->{'To'}."\r
$paraRRouteFct\r
".$strctSIPFct->HCall_ID->{'Call_ID'}."\r
".$strctSIPFct->HCSeq->{'CSeq'}."\r
".$strctSIPFct->DiversComplet."\r
Content-Length: 0\r\n" ;
    }
    elsif ($optionFct eq 'send') {
	# Ringing sended and need to be forwarded.
	# We compose the Via: field : we add the proxy SIP on the path.
	my $paraViaFct = &Packet_viaCompose('rec', $strctSIPFct->TabVia, $serverPeerHostFct, $serverPeerPortFct) ;
	# Message composition.
	$messageRingingFct = "SIP/2.0 180 Ringing
$paraViaFct\r
".$strctSIPFct->HFrom->{'From'}."\r
".$strctSIPFct->HTo->{'To'}."\r
".$strctSIPFct->HCall_ID->{'Call_ID'}."\r
".$strctSIPFct->HCSeq->{'CSeq'}."\r
".$strctSIPFct->DiversComplet."\r
Content-Length: 0\r\n" ;
    }

    $messageRingingFct =~ s/\r\n\r\n/\r\n/g ;
    $messageRingingFct = $messageRingingFct."\r\n" ;
    return($messageRingingFct) ;
}


###########################################################################
# Compose the Trying response to send.
# Args: ($optionFct, $strctSIPFct, $serverPeerHostFct, $serverPeerPortFct)
#   $optionFct : Indicate if the Trying message is created before being
#                send ("send").
#   $strctSIPFct : SIP header information in a structure.
#   $serverPeerHostFct : The peer host address which send the Trying.
#   $serverPeerPortFct : The peer host port which send the Trying.
# Returns: $messageRingingFct : The Ringing message to send.
# Comment:
#    None
###########################################################################
sub Packet_messageTrying {    
    # 21.1.1, RFC 3261 : The 100 (Trying) response is different from other provisional responses, in that it is never forwarded upstream by a stateful proxy.
    
    print "[DEBUG] Packet.pm, Enter in the messageTrying function\n" ;
    
    my $optionFct = $_[0] ;
    my $strctSIPFct = $_[1] ;
    my $serverPeerHostFct = $_[2] ;
    my $serverPeerPortFct = $_[3] ;
    my $messageTryingFct = '' ;
    
    # Here the code called when we need to send a Trying response
    if ($optionFct eq 'send') {
	# We compose the Via: field : we keep all fields. We add received parameter.
	my $paraViaFct = &Packet_viaCompose('rec', $strctSIPFct->TabVia, $serverPeerHostFct, $serverPeerPortFct) ;
	# Message composition.
	$messageTryingFct = "SIP/2.0 100 Trying\r
$paraViaFct\r
".$strctSIPFct->HFrom->{'From'}."\r
".$strctSIPFct->HTo->{'To'}."\r
".$strctSIPFct->HCall_ID->{'Call_ID'}."\r
".$strctSIPFct->HCSeq->{'CSeq'}."\r
".$strctSIPFct->DiversComplet."\r
Content-Length: 0\r\n" ;
    }

    $messageTryingFct =~ s/\r\n\r\n/\r\n/g ;
    $messageTryingFct = $messageTryingFct."\r\n" ;
    return($messageTryingFct) ;
}


###########################################################################
# Compose the ACK primitive to send or to forward.
# Args: ($optionFct, $strctSIPFct, $serverPeerHostFct, $serverPeerPortFct)
#   $optionFct : Indicate if the ACK message is created before being
#                send ("send") or just modifiy before being
#                forwarded ("forward").
#   $strctSIPFct : SIP header information in a structure.
#   $serverPeerHostFct : The peer host address which send the ACK.
#   $serverPeerPortFct : The peer host port which send the ACK.
# Returns: $messageACKFct : The ACK message to send.
# Comment:
#    None
###########################################################################
sub Packet_messageACK {

    print "[DEBUG] Packet.pm, Enter in the messageACK function\n" ;

    my $optionFct = $_[0] ;
    my $strctSIPFct = $_[1] ;
    my $serverPeerHostFct = $_[2] ;
    my $serverPeerPortFct = $_[3] ;
    my $nextHopFct = $_[4] ;
    my $messageACKFct = '' ;
    
    # Here the code called when we need to send a ACK message.
    if ($optionFct eq 'send') {
	# Message composition where we keep only the Via: on the top of the stack.
	$messageACKFct = "ACK sip:".$strctSIPFct->HTo->{'To_Num'}."\@$nextHopFct SIP/2.0\r
".$strctSIPFct->TabVia->[0]."\r
".$strctSIPFct->HFrom->{'From'}."\r
".$strctSIPFct->HTo->{'To'}."\r
Max-Forwards: 70\r
".$strctSIPFct->HCall_ID->{'Call_ID'}."\r
CSeq: ".$strctSIPFct->HCSeq->{'CSeq_Num'}." ACK\r
".$strctSIPFct->DiversComplet."\r
Content-Length: 0\r\n" ;
    }
    elsif ($optionFct eq 'forward') {
	# We compose the Via: field : we add "received" informations on the fist Via: and add the server address and port proxy SIP in a new Via:.
	my $paraViaFct = &Packet_viaCompose('ajout', $strctSIPFct->TabVia, $serverPeerHostFct, $serverPeerPortFct) ;
	# We delete the first Route:. We must care if there the field is empty that.
	shift(@{$strctSIPFct->TabRoute}) ;
	my $paraRouteFct = join("\r\n", @{$strctSIPFct->TabRoute}) ;
	
	# Message composition.
	$messageACKFct = $strctSIPFct->HLigneEtat->{'LigneEtat'}."\r
$paraViaFct\r
$paraRouteFct\r
".$strctSIPFct->HFrom->{'From'}."\r
".$strctSIPFct->HTo->{'To'}."\r
Max-Forwards: ".($strctSIPFct->HMax_Forwards->{'Max_Forwards_Valeur'} - 1)."\r
".$strctSIPFct->HCall_ID->{'Call_ID'}."\r
".$strctSIPFct->HCSeq->{'CSeq'}."\r
".$strctSIPFct->DiversComplet."\r
Content-Length: 0\r\n" ;
    }

    $messageACKFct =~ s/\r\n\r\n/\r\n/g ;
    $messageACKFct = $messageACKFct."\r\n" ;
    return($messageACKFct) ;
}


###########################################################################
# Compose the INVITE primitive to send or to forward.
# Args: ($optionFct, $strctSIPFct, $serverPeerHostFct, $serverPeerPortFct)
#   $optionFct : Indicate if the INVITE message is created before being
#                send ("send") or just modifiy before being
#                forwarded ("forward").
#   $strctSIPFct : SIP header information in a structure.
#   $serverPeerHostFct : The peer host address which send the INVITE.
#   $serverPeerPortFct : The peer host port which send the INVITE.
# Returns: $messageINVITEFct : The INVITE message to send.
# Comment:
#    None
###########################################################################
sub Packet_messageINVITE {

    print "[DEBUG] Packet.pm, Enter in the messageINVITE function\n" ;

    my $optionFct = $_[0] ;
    my $strctSIPFct = $_[1] ;
    my $serverPeerHostFct = $_[2] ;
    my $serverPeerPortFct = $_[3] ;
    my $nextHopFct = $_[4] ;
    my $messageINVITEFct = '' ;

    
    if ($optionFct eq 'forward') {
	# We add a received= parameter and the proxy SIP address & port to be on the communication path.
	my $paraViaRRouteFct = &Packet_viaCompose('ajout', $strctSIPFct->TabVia, $serverPeerHostFct, $serverPeerPortFct) ;
	
	# Record-Route composition : we add the proxy SIP to be on the communication path.
	unshift(@{$strctSIPFct->TabRRoute}, "Record-Route: <sip:$ADRESSESRV;lr>") ;
	my $paraRRouteFct = join("\r\n", @{$strctSIPFct->TabRRoute}) ;
	
	# We combine the Via: and Record-Route: fields ... if there is a Record-Route: field.
	$paraViaRRouteFct = $paraViaRRouteFct."\r\n".$paraRRouteFct unless (!$paraRRouteFct) ;
	
	# Message composition.
	$messageINVITEFct = $strctSIPFct->HLigneEtat->{'LigneEtat'}."\r
$paraViaRRouteFct\r
".$strctSIPFct->HFrom->{'From'}."\r
".$strctSIPFct->HTo->{'To'}."\r
".$strctSIPFct->HCall_ID->{'Call_ID'}."\r
".$strctSIPFct->HCSeq->{'CSeq'}."\r
Max-Forwards: ".($strctSIPFct->HMax_Forwards->{'Max_Forwards_Valeur'} - 1)."\r
".$strctSIPFct->HProxy_Authorization->{'Proxy_Authorization'}."\r
".$strctSIPFct->DiversComplet."\r
".$strctSIPFct->Content_Type."\r
".$strctSIPFct->Content_Length."\r\n" ;
    }
    elsif ($optionFct eq 'send') {
	$messageINVITEFct = $strctSIPFct->HLigneEtat->{'LigneEtat'}."\r
".$strctSIPFct->TabVia->[0]."\r
".$strctSIPFct->HFrom->{'From'}."\r
".$strctSIPFct->HTo->{'To'}."\r
".$strctSIPFct->HCall_ID->{'Call_ID'}."\r
".$strctSIPFct->HCSeq->{'CSeq'}."\r
".$strctSIPFct->HMax_Forwards->{'Max_Forwards'}."\r
".$strctSIPFct->HProxy_Authorization->{'Proxy_Authorization'}."\r
".$strctSIPFct->DiversComplet."\r
".$strctSIPFct->Content_Type."\r
".$strctSIPFct->Content_Length."\r\n" ;
    }
    
    $messageINVITEFct =~ s/\r\n\r\n/\r\n/g ;
    $messageINVITEFct = $messageINVITEFct."\r\n".$strctSIPFct->CorpsMessage ;
    return($messageINVITEFct) ;
}


###########################################################################
# Compose the CANCEL primitive to send or to forward.
# Args: ($optionFct, $strctSIPFct, $serverPeerHostFct, $serverPeerPortFct)
#   $optionFct : Indicate if the CANCEL message is created before being
#                send ("send") or just modifiy before being
#                forwarded ("forward").
#   $strctSIPFct : SIP header information in a structure.
#   $serverPeerHostFct : The peer host address which send the CANCEL.
#   $serverPeerPortFct : The peer host port which send the CANCEL.
# Returns: $messageCANCELFct : The CANCEL message to send.
# Comment:
#    None
###########################################################################
sub Packet_messageCANCEL {

    print "[DEBUG] Packet.pm, Enter in the messageCANCEL function\n" ;

    my $optionFct = $_[0] ;
    my $strctSIPFct = $_[1] ;
    my $serverPeerHostFct = $_[2] ;
    my $serverPeerPortFct = $_[3] ;
#    my $nextHopFct = $_[4] ;
    my $messageCANCELFct = '' ;

    if ($optionFct eq 'send') {

	# We search the communication number to find next the branch.
	my $numCommFct = &Listing_findComm($strctSIPFct->HCall_ID->{'Call_ID_ID'}) ;

	# We create the Via: field with the branch registered.
	my $paraViaFct = &Packet_viaCompose('crea', 0, 0, 0, $TabCommBranchEgress[$numCommFct]) ;

	# Message composition. We keep all fields. Max-Forwards: is initialized.
	$messageCANCELFct = $strctSIPFct->HLigneEtat->{'LigneEtat'}."\r
$paraViaFct\r
".$strctSIPFct->HFrom->{'From'}."\r
".$strctSIPFct->HTo->{'To'}."\r
".$strctSIPFct->HCall_ID->{'Call_ID'}."\r
CSeq: ".$strctSIPFct->HCSeq->{'CSeq_Num'}." CANCEL\r
Max-Forwards: 70\r
".$strctSIPFct->DiversComplet."\r
Content-Length: 0\r\n" ;
    }
    elsif ($optionFct eq 'forward') {

    }

    $messageCANCELFct =~ s/\r\n\r\n/\r\n/g ;
    $messageCANCELFct = $messageCANCELFct."\r\n" ;
    return($messageCANCELFct) ;
}


###########################################################################
# Compose the BYE primitive to send or to forward.
# Args: ($optionFct, $strctSIPFct, $serverPeerHostFct, $serverPeerPortFct)
#   $optionFct : Indicate if the BYE message is created before being
#                send ("send") or just modifiy before being
#                forwarded ("forward").
#   $strctSIPFct : SIP header information in a structure.
#   $serverPeerHostFct : The peer host address which send the BYE.
#   $serverPeerPortFct : The peer host port which send the BYE.
# Returns: $messageBYEFct : The BYE message to send.
# Comment:
#    None
###########################################################################
sub Packet_messageBYE {

    print "[DEBUG] Packet.pm, Enter in the messageBYE function\n" ;

    my $optionFct = $_[0] ;
    my $strctSIPFct = $_[1] ;
    my $serverPeerHostFct = $_[2] ;
    my $serverPeerPortFct = $_[3] ;
    my $nextHopFct = $_[4] ;
    my $messageBYEFct = '' ;


    if ($optionFct eq 'send') {
	my $paraRouteFct = "" ; # TEST :  coder.

	$messageBYE = $strctSIPFct->HLigneEtat->{'LigneEtat'}."\r
".$strctSIPFct->TabVia->[0]."\r
$paraRouteFct\r
".$strctSIPFct->HFrom->{'From'}."\r
".$strctSIPFct->HTo->{'To'}."\r
Max-Forwards: 70\r
".$strctSIPFct->HCall_ID->{'Call_ID'}."\r
".$strctSIPFct->HCSeq->{'CSeq'}."\r
".$strctSIPFct->DiversComplet."\r
Content-Length: 0\r\n" ;	
    }
    elsif ($optionFct eq 'forward') {
	# We compose the Via: field : we add "received" informations on the fist Via: and add the server address and port proxy SIP in a new Via:.
	my $paraViaFct = &Packet_viaCompose('ajout', $strctSIPFct->TabVia, $serverPeerHostFct, $serverPeerPortFct) ;
	# We delete the first Route:. We must care if there the field is empty that.
	shift(@{$strctSIPFct->TabRoute}) ;
	my $paraRouteFct = join("\r\n", @{$strctSIPFct->TabRoute}) ;
	
#	# We combine all Via: and Route; fields. Like this, if Route: field is empty, il will not cause some trouble.
#	$paraViaRouteFct = $paraViaRouteFct."\r\n".$paraRouteFct unless (!$paraRouteFct) ;
	
	# Message composition.
	$messageBYEFct = $strctSIPFct->HLigneEtat->{'LigneEtat'}."\r
$paraViaFct\r
$paraRouteFct\r
".$strctSIPFct->HFrom->{'From'}."\r
".$strctSIPFct->HTo->{'To'}."\r
Max-Forwards: ".($strctSIPFct->HMax_Forwards->{'Max_Forwards_Valeur'} - 1)."\r
".$strctSIPFct->HCall_ID->{'Call_ID'}."\r
".$strctSIPFct->HCSeq->{'CSeq'}."\r
".$strctSIPFct->DiversComplet."\r
Content-Length: 0\r\n" ;
    }
    
    $messageBYEFct =~ s/\r\n\r\n/\r\n/g ;
    $messageBYEFct = $messageBYEFct."\r\n" ;
    return($messageBYEFct) ;
}


###########################################################################
# Compose the REFER primitive to send or to forward.
# Args: ($optionFct, $strctSIPFct, $serverPeerHostFct, $serverPeerPortFct)
#   $optionFct : Indicate if the REFER message is created before being
#                send ("send") or just modifiy before being
#                forwarded ("forward").
#   $strctSIPFct : SIP header information in a structure.
#   $serverPeerHostFct : The peer host address which send the REFER.
#   $serverPeerPortFct : The peer host port which send the REFER.
# Returns: $messageREFERFct : The REFER message to send.
# Comment:
#    None
###########################################################################
sub Packet_messageREFER {
    print "[DEBUG] Packet.pm, Enter in the messageREFER function\n" ;

    my $optionFct = $_[0] ;
    my $strctSIPFct = $_[1] ;
    my $serverPeerHostFct = $_[2] ;
    my $serverPeerPortFct = $_[3] ;
    my $nextHopFct = $_[4] ;
    my $messageREFERFct = '' ;


    if ($optionFct eq 'send') {
	# Create the Via: header.
	$paraViaFct = &Packet_viaCompose('crea') ;
	# $paraRouteFct = "Route: <sip:$ADRESSESRV;branch=$branchFct;lr>" ;
	
	# Message composition.
	$messageREFERFct = $strctSIPFct->HLigneEtat->{'LigneEtat'}."\r
$paraViaFct\r
$paraRouteFct\r
".$strctSIPFct->HFrom->{'From'}."\r
".$strctSIPFct->HTo->{'To'}."\r
".$strctSIPFct->HCall_ID->{'Call_ID'}."\r
".$strctSIPFct->HCSeq->{'CSeq'}."\r
".$strctSIPFct->HContact->{'Contact'}."\r
".$strctSIPFct->HMax_Forwards->{'Max_Forwards'}."\r
".$strctSIPFct->DiversComplet."\r
Content-Length: 0\r\n" ;
    }
    elsif ($optionFct eq 'forward') {
	# We compose the Via: field : we add "received" informations on the first Via: and add the server address and port proxy SIP in a new Via:.
	my $paraViaFct = &Packet_viaCompose('ajout', $strctSIPFct->TabVia, $serverPeerHostFct, $serverPeerPortFct) ;
	# We delete the first Route:. We must care if there the field is empty that.
	shift(@{$strctSIPFct->TabRoute}) ;
	my $paraRouteFct = join("\r\n", @{$strctSIPFct->TabRoute}) ;
#	# We combine all Via: and Route; fields. Like this, if Route: field is empty, il will not cause some trouble.
#	$paraViaRouteFct = $paraViaRouteFct."\r\n".$paraRouteFct unless (!$paraRouteFct) ;
	# Delete 1 on Max-Forwards.
	$strctSIPFct->HMax_Forwards->{'Max_Forwards_Valeur'} = $strctSIPFct->HMax_Forwards->{'Max_Forwards_Valeur'} - 1 ;

	# Message composition.
	$messageREFERFct = $strctSIPFct->HLigneEtat->{'LigneEtat'}."\r
$paraViaFct\r
$paraRouteFct\r
".$strctSIPFct->HFrom->{'From'}."\r
".$strctSIPFct->HTo->{'To'}."\r
".$strctSIPFct->HCall_ID->{'Call_ID'}."\r
".$strctSIPFct->HCSeq->{'CSeq'}."\r
Max-Forwards: ".$strctSIPFct->HMax_Forwards->{'Max_Forwards_Valeur'}."\r
".$strctSIPFct->DiversComplet."\r
Content-Length: 0\r\n" ;
    }

    $messageREFERFct =~ s/\r\n\r\n/\r\n/g ;
    $messageREFERFct = $messageREFERFct."\r\n" ;
    return($messageREFERFct) ;
}


###########################################################################
# Compose the 3xx response to send or to forward.
# Args: ($optionFct, $strctSIPFct, $serverPeerHostFct, $serverPeerPortFct)
#   $optionFct : Indicate if the 3xx message is created before being
#                send ("send") or just modifiy before being
#                forwarded ("forward").
#   $strctSIPFct : SIP header information in a structure.
#   $serverPeerHostFct : The peer host address which send the 3xx.
#   $serverPeerPortFct : The peer host port which send the 3xx.
#   $lineStateFct : The SIP Line State.
# Returns: $message3xxFct : The 3xx message to send.
# Comment:
#    None
###########################################################################
sub Packet_message3xx {

    print "[DEBUG] Packet.pm, Enter in the message3xx function\n" ;
    
    my $optionFct = $_[0] ;
    my $strctSIPFct = $_[1] ;
    my $serverPeerHostFct = $_[2] ;
    my $serverPeerPortFct = $_[3] ;
    my $lineStateFct = $_[4] ;
    my $message3xxFct = '' ;

    if ($optionFct eq 'forward') {
	# Via: field composition.
	my $paraViaFct = &Packet_viaCompose('suppr', $strctSIPFct->TabVia, 0, 0) ;
	# Message composition.
	$message3xxFct = "$lineStateFct\r
$paraViaFct\r
".$strctSIPFct->HFrom->{'From'}."\r
".$strctSIPFct->HTo->{'To'}."\r
".$strctSIPFct->HCall_ID->{'Call_ID'}."\r
".$strctSIPFct->HCSeq->{'CSeq'}."\r
".$strctSIPFct->DiversComplet."\r
Content-Length: 0\r\n" ;
    }

    $message3xxFct =~ s/\r\n\r\n/\r\n/g ;
    $message3xxFct = $message3xxFct."\r\n" ;
    return($message3xxFct) ;
}


###########################################################################
# Compose the 4xx response to send or to forward.
# Args: ($optionFct, $strctSIPFct, $serverPeerHostFct, $serverPeerPortFct)
#   $optionFct : Indicate if the 4xx message is created before being
#                send ("send") or just modifiy before being
#                forwarded ("forward").
#   $strctSIPFct : SIP header information in a structure.
#   $serverPeerHostFct : The peer host address which send the 4xx.
#   $serverPeerPortFct : The peer host port which send the 4xx.
#   $lineStateFct : The SIP Line State.
# Returns: $message4xxFct : The 4xx message to send.
# Comment:
#    None
###########################################################################
sub Packet_message4xx {

    print "[DEBUG] Packet.pm, Enter in the message4xx function\n" ;
    
    my $optionFct = $_[0] ;
    my $strctSIPFct = $_[1] ;
    my $serverPeerHostFct = $_[2] ;
    my $serverPeerPortFct = $_[3] ;
    my $lineStateFct = $_[4] ;
    my $message4xxFct = '' ;

    if ($optionFct eq 'forward') {
	# Via: field composition.
	my $paraViaFct = &Packet_viaCompose('suppr', $strctSIPFct->TabVia, 0, 0) ;
	# Message composition.
	$message4xxFct = "$lineStateFct\r
$paraViaFct\r
".$strctSIPFct->HFrom->{'From'}."\r
".$strctSIPFct->HTo->{'To'}."\r
".$strctSIPFct->HCall_ID->{'Call_ID'}."\r
".$strctSIPFct->HCSeq->{'CSeq'}."\r
".$strctSIPFct->DiversComplet."\r
Content-Length: 0\r\n" ;
    }
    elsif ($optionFct eq 'send') {
	# Via: field composition.
	my $paraViaFct = join("\r\n", @{$strctSIPFct->TabVia}) ;

	# Message composition.
	$message4xxFct = "$lineStateFct\r
$paraViaFct\r
".$strctSIPFct->HFrom->{'From'}."\r
".$strctSIPFct->HTo->{'To'}."\r
".$strctSIPFct->HCall_ID->{'Call_ID'}."\r
".$strctSIPFct->HCSeq->{'CSeq'}."\r
".$strctSIPFct->DiversComplet."\r
Content-Length: 0\r\n" ;
    }
    
    $message4xxFct =~ s/\r\n\r\n/\r\n/g ;
    $message4xxFct = $message4xxFct."\r\n" ;
    return($message4xxFct) ;
}


###########################################################################
# Compose the 5xx response to send or to forward.
# Args: ($optionFct, $strctSIPFct, $serverPeerHostFct, $serverPeerPortFct)
#   $optionFct : Indicate if the 5xx message is created before being
#                send ("send") or just modifiy before being
#                forwarded ("forward").
#   $strctSIPFct : SIP header information in a structure.
#   $serverPeerHostFct : The peer host address which send the 5xx.
#   $serverPeerPortFct : The peer host port which send the 5xx.
#   $lineStateFct : The SIP Line State.
# Returns: $message5xxFct : The 5xx message to send.
# Comment:
#    None
###########################################################################
sub Packet_message5xx {

    print "[DEBUG] Packet.pm, Enter in the message5xx function\n" ;
    
    my $optionFct = $_[0] ;
    my $strctSIPFct = $_[1] ;
    my $serverPeerHostFct = $_[2] ;
    my $serverPeerPortFct = $_[3] ;
    my $lineStateFct = $_[4] ;
    my $message5xxFct = '' ;

    if ($optionFct eq 'forward') {
	# Via: field composition.
	my $paraViaFct = &Packet_viaCompose('suppr', $strctSIPFct->TabVia, 0, 0) ;
	# Message composition.
	$message5xxFct = "$lineStateFct\r
$paraViaFct\r
".$strctSIPFct->HFrom->{'From'}."\r
".$strctSIPFct->HTo->{'To'}."\r
".$strctSIPFct->HCall_ID->{'Call_ID'}."\r
".$strctSIPFct->HCSeq->{'CSeq'}."\r
".$strctSIPFct->DiversComplet."\r
Content-Length: 0\r\n" ;
    }
    elsif ($optionFct eq 'send') {
	# Via: field composition.
	my $paraViaFct = join("\r\n", @{$strctSIPFct->TabVia}) ;

	# Message composition.
	$message5xxFct = "$lineStateFct\r
$paraViaFct\r
".$strctSIPFct->HFrom->{'From'}."\r
".$strctSIPFct->HTo->{'To'}."\r
".$strctSIPFct->HCall_ID->{'Call_ID'}."\r
".$strctSIPFct->HCSeq->{'CSeq'}."\r
".$strctSIPFct->DiversComplet."\r
Content-Length: 0\r\n" ;
    }
    
    $message5xxFct =~ s/\r\n\r\n/\r\n/g ;
    $message5xxFct = $message5xxFct."\r\n" ;
    return($message5xxFct) ;
}


###########################################################################
# Compose the 6xx response to send or to forward.
# Args: ($optionFct, $strctSIPFct, $serverPeerHostFct, $serverPeerPortFct)
#   $optionFct : Indicate if the 6xx message is created before being
#                send ("send") or just modifiy before being
#                forwarded ("forward").
#   $strctSIPFct : SIP header information in a structure.
#   $serverPeerHostFct : The peer host address which send the 6xx.
#   $serverPeerPortFct : The peer host port which send the 6xx.
#   $lineStateFct : The SIP Line State.
# Returns: $message6xxFct : The 6xx message to send.
# Comment:
#    None
###########################################################################
sub Packet_message6xx {

    print "[DEBUG] Packet.pm, Enter in the message6xx function\n" ;
    
    my $optionFct = $_[0] ;
    my $strctSIPFct = $_[1] ;
    my $serverPeerHostFct = $_[2] ;
    my $serverPeerPortFct = $_[3] ;
    my $lineStateFct = $_[4] ;
    my $message6xxFct = '' ;

    if ($optionFct eq 'forward') {
	# Via: field composition.
	my $paraViaFct = &Packet_viaCompose('suppr', $strctSIPFct->TabVia, 0, 0) ;
	# Record-Route: field composition.
	my $paraRRouteFct = join("\r\n", @{$strctSIPFct->TabRRoute}) ;
	# Message composition.
	$message6xxFct = "$lineStateFct\r
$paraViaFct\r
$paraRRouteFct\r
".$strctSIPFct->HFrom->{'From'}."\r
".$strctSIPFct->HTo->{'To'}."\r
".$strctSIPFct->HCall_ID->{'Call_ID'}."\r
".$strctSIPFct->HCSeq->{'CSeq'}."\r
".$strctSIPFct->DiversComplet."\r
Content-Length: 0\r\n" ;
    }
    elsif ($optionFct eq 'send') {
	# Via: field composition.
	my $paraViaFct = join("\r\n", @{$strctSIPFct->TabVia}) ;
	
	# Message composition.
	$message6xxFct = "$lineStateFct\r
$paraViaFct\r
".$strctSIPFct->HFrom->{'From'}."\r
".$strctSIPFct->HTo->{'To'}."\r
".$strctSIPFct->HCall_ID->{'Call_ID'}."\r
".$strctSIPFct->HCSeq->{'CSeq'}."\r
".$strctSIPFct->DiversComplet."\r
Content-Length: 0\r\n" ;
    }
    
    $message6xxFct =~ s/\r\n\r\n/\r\n/g ;
    $message6xxFct = $message6xxFct."\r\n" ;
    return($message6xxFct) ;
}


###########################################################################
# Compose the REGISTER message to send or to forward.
# Args: ($optionFct, $strctSIPFct, $serverPeerHostFct, $serverPeerPortFct)
#   $optionFct : Indicate if the REGISTER message is created before being
#                send ("send").
#   $strctSIPFct : SIP header information in a structure.
#   $serverPeerHostFct : The peer host address which send the 6xx.
#   $serverPeerPortFct : The peer host port which send the 6xx.
# Returns: $messageREGISTERFct : The REGISTER message to send.
# Comment:
#    None
###########################################################################
sub Packet_messageREGISTER {
    
    print "[DEBUG] Packet.pm, Enter in the messageREGISTER function\n" ;
    
    my $optionFct = $_[0] ;
    my $strctSIPFct = $_[1] ;
    my $serverPeerHostFct = $_[2] ;
    my $serverPeerPortFct = $_[3] ;
    my $messageREGISTERFct = '' ;


    if ($optionFct eq 'send') {
	# Via: field composition.
	my $paraViaFct = join("\r\n", @{$strctSIPFct->TabVia}) ;

	$messageREGISTERFct = $strctSIPFct->HLigneEtat->{'LigneEtat'}."\r
$paraViaFct\r
".$strctSIPFct->HFrom->{'From'}."\r
".$strctSIPFct->HTo->{'To'}."\r
".$strctSIPFct->HCall_ID->{'Call_ID'}."\r
".$strctSIPFct->HCSeq->{'CSeq'}."\r
".$strctSIPFct->HMax_Forwards->{'Max_Forwards'}."\r
".$strctSIPFct->HContact->{'Contact'}."\r
".$strctSIPFct->HProxy_Authorization->{'Proxy_Authorization'}."\r
".$strctSIPFct->DiversComplet."\r
".$strctSIPFct->Content_Length."\r\n" ;
    }

    $messageREGISTERFct =~ s/\r\n\r\n/\r\n/g ;
    $messageREGISTERFct = $messageREGISTERFct."\r\n" ;

    return($messageREGISTERFct) ;
}


###########################################################################
# Compose the NOTIFY message to send or to forward.
# Args: ($optionFct, $strctSIPFct, $serverPeerHostFct, $serverPeerPortFct)
#   $optionFct : Indicate if the NOTIFY message is created before being
#                send ("send") or just modifiy before being
#                forwarded ("forward").
#   $strctSIPFct : SIP header information in a structure.
#   $serverPeerHostFct : The peer host address which send the 6xx.
#   $serverPeerPortFct : The peer host port which send the 6xx.
# Returns: $messageNOTIFYFct : The NOTIFY message to send.
# Comment:
#    None
###########################################################################
sub Packet_messageNOTIFY {
    
    print "[DEBUG] Packet.pm, Enter in the messageNOTIFY function\n" ;
    
    my $optionFct = $_[0] ;
    my $strctSIPFct = $_[1] ;
    my $serverPeerHostFct = $_[2] ;
    my $serverPeerPortFct = $_[3] ;
    my $messageNOTIFYFct = '' ;
    
    if ($optionFct eq 'send') {
	# We search the communication number to find next the branch.
	my $numCommFct = &Listing_findComm($strctSIPFct->HCall_ID->{'Call_ID_ID'}) ;
	# We create the Via: field with the branch registered.
	my $paraViaFct = &Packet_viaCompose('crea', 0, 0, 0, $TabCommBranchEgress[$numCommFct]) ;
	# We keep the Expires value.
	(my $expires_ValueFct) = $strctSIPFct->DiversComplet =~ /Expires: (\S*)/ ;
	
	# Message composition.
	$messageNOTIFYFct = 'NOTIFY sip:'.$strctSIPFct->HTo->{'To_Num'}.'@'.$strctSIPFct->HTo->{'To_AdrIP'}." SIP/2.0\r
$paraViaFct\r
".$strctSIPFct->HFrom->{'From'}."\r
".$strctSIPFct->HTo->{'To'}."\r
".$strctSIPFct->HCall_ID->{'Call_ID'}."\r
CSeq: ".&Packet_compoTagBranchNum("n")." NOTIFY\r
".$strctSIPFct->DiversComplet."\r
Subscription-State: active;expires:$expires_ValueFct\r
Content-Type: application/simple-message-summary\r
Content-Length: ".length($strctSIPFct->CorpsMessage)."\r\n" ;
    }

    elsif ($optionFct eq 'forward') {
	my $paraViaFct = &Packet_viaCompose('ajout', $strctSIPFct->TabVia, $serverPeerHostFct, $serverPeerPortFct) ;
	# We delete the first Route:. We must care if there the field is empty.
	shift(@{$strctSIPFct->TabRoute}) ;
	my $paraRouteFct = join("\r\n", @{$strctSIPFct->TabRoute}) ;
	
	# Message composition.
	$messageNOTIFYFct = $strctSIPFct->HLigneEtat->{'LigneEtat'}."\r
$paraViaFct\r
$paraRouteFct\r
".$strctSIPFct->HFrom->{'From'}."\r
".$strctSIPFct->HTo->{'To'}."\r
".$strctSIPFct->HCall_ID->{'Call_ID'}."\r
".$strctSIPFct->HCSeq->{'CSeq'}."\r
Max-Forwards: ".($strctSIPFct->HMax_Forwards->{'Max_Forwards_Valeur'} - 1)."\r
".$strctSIPFct->DiversComplet."\r
".$strctSIPFct->Content_Type."\r
".$strctSIPFct->Content_Length."\r\n" ;
    }

    $messageNOTIFYFct =~ s/\r\n\r\n/\r\n/g ;
    $messageNOTIFYFct = $messageNOTIFYFct."\r\n".$strctSIPFct->CorpsMessage ;
    return($messageNOTIFYFct) ;
}
1 ;
