#!/usr/bin/perl

######################################################################################
#                                     PROXY ET REGISTER SIP                          #
# AUTEUR : Guillaume Lehmann                                                         #
# Pour tout renseignement, lehmann@free.fr                                           #
# Ce logiciel est sous licence GPL v3 (http://www.gnu.org)                           #
# v 0.1 du 09/09/2007   v0.21 du 05/04/2008  v0.41 du 09/04/2009  v0.61 du 09/05/2010#
# v 0.2 du 17/09/2007   v0.22 du 08/04/2008  v0.42 du 12/04/2009  v0.62 du 15/05/2010#
# v 0.3 du 18/09/2007   v0.23 du 15/04/2008  v0.43 du 22/04/2009  v0.63 du 18/05/2010#
# v 0.4 du 20/09/2007   v0.24 du 27/05/2008  v0.44 du 23/04/2009  v0.64 du 30/05/2010#
# v 0.5 du 24/09/2007   v0.25 du 31/05/2008  v0.45 du 25/04/2009  v0.65 du 06/06/2010#
# v 0.6 du 20/10/2007   v0.26 du 01/06/2008  v0.46 du 01/05/2009  v0.66 du 13/06/2010#
# v 0.7 du 10/11/2007   v0.27 du 07/06/2008  v0.47 du 24/06/2009  v0.67 du xx/xx/2010#
# v 0.8 du 29/11/2007   v0.28 du 06/07/2008  v0.48 du 27/06/2009  v0.68 du xx/xx/2010#
# v 0.9 du 01/12/2007   v0.29 du 07/07/2008  v0.49 du 28/06/2009  v0.69 du xx/xx/2010#
# v 0.10 du 02/12/2007  v0.30 du 08/07/2008  v0.50 du 30/06/2009  v0.70 du xx/xx/2010#
# v 0.11 du 08/12/2007  v0.31 du 11/07/2008  v0.51 du 10/07/2009  v0.71 du xx/xx/2010#
# v 0.12 du 09/12/2007  v0.32 du 18/07/2008  v0.52 du 20/09/2009  v0.72 du xx/xx/2010#
# v 0.13 du 02/01/2008  v0.33 du 21/07/2008  v0.53 du 19/10/2009  v0.73 du xx/xx/2010#
# v 0.14 du 06/01/2008  v0.34 du 06/08/2008  v0.54 du 05/03/2010  v0.74 du xx/xx/2010#
# v 0.15 du 10/01/2008  v0.35 du 16/09/2008  v0.55 du 18/03/2010  v0.75 du xx/xx/2010#
# v 0.16 du 11/01/2008  v0.36 du 19/09/2008  v0.56 du 20/03/2010  v0.76 du xx/xx/2010#
# v 0.17 du 12/01/2008  v0.37 du 28/09/2008  v0.57 du 24/03/2010  v0.77 du xx/xx/2010#
# v 0.18 du 16/01/2008  v0.38 du 29/09/2008  v0.58 du 27/03/2010  v0.78 du xx/xx/2010#
# v 0.19 du 19/01/2008  v0.39 du 30/09/2008  v0.59 du 16/04/2010  v0.79 du xx/xx/2010#
# v 0.20 du 21/01/2008  v0.40 du 02/11/2008  v0.60 du 07/05/2010  v0.80 du xx/xx/2010#
######################################################################################

# Compter le nombre de lignes de code : 
# less pabx.pl | grep  '} #' | nl && sleep 2 && less pabx.pl | grep  '{ #' | nl && sleep 2 && less pabx.pl | grep  '; #' | nl && sleep 2 && less pabx.pl | grep -v '#' | nl



use IO::Socket::INET ;
use Digest::MD5 'md5_hex' ;
use threads ;
use threads::shared ;
use Time::HiRes qw (usleep gettimeofday) ;
#use Time::localtime ;
use strict ;
# use warnings ;
use Class::Struct qw(struct) ;




# Licence
print "    --== Logiciel de Guillaume Lehmann (email : lehmann AT free POINT fr) ==-- \n" ;
print "--== Logiciel sous licence GPL v3 (http://www.gnu.org/licenses/gpl-3.0.html) ==--\n\n" ;

# Pour ne pas avoir  faire un wait  la mort d'un processus fils sans avoir peur de crer un zombie.
$SIG{'CHLD'} = 'IGNORE' ;

######################################
# DECLARATION DES VARIABLES PARTAGEES
our @TabComm : shared ;
our @TabCommCycleNow : shared ;
our @TabCommMess : shared ;
our @TabCommDest : shared ;
our @TabCommCycleInit : shared ;
our @TabCommBranchIngress : shared ;
our @TabCommBranchEgress : shared ;
our @TabSession : shared ;
######################################


#########################################################
# DECLARATION ET INITIALISATION DES VARIABLES HORS BOUCLE
#my @TabVia = () ; 
#my @TabRRoute = () ; 
#my @TabRoute  = () ; 
#my %HProxy_Authorization ;
#my %HCall_ID ;
#my %HContact ;
#my %HCSeq  ;
#my %HFrom ;
#my %HTo ;
#my %HMax_Forwards ;
#my %HLigneEtat ;

my $message = '' ;
my $DiversComplet = '' ;
my $RefHProxy_Authorization ;
my $RefHCall_ID ;
my $RefHContact ;
my $Content_Type = '' ;
my $Content_Length = '' ;
my $RefHCSeq ;
my $RefHFrom ;
my $RefHMax_Forwards ;
my $Subscription_State = '' ;
my $RefHTo ;
my $RefTabVia ;
my $RefTabRRoute ;
my $RefTabRoute ;
my $RefHLigneEtat = '' ;
my $CorpsMessage = '' ;

my $NumComm = -1 ;

# Structures.
struct SIPHeader => [DiversComplet => '$',
		     HProxy_Authorization => '%',
		     HCall_ID => '%',
		     HContact => '%',
		     Content_Type => '$',
		     Content_Length => '$',
		     HCSeq => '%',
		     HFrom => '%',
		     HTo => '%',
		     TabVia => '@',
		     HMax_Forwards => '%',
		     Subscription_State => '$',
		     TabRRoute => '@',
		     TabRoute => '@',
		     HLigneEtat => '%',
		     CorpsMessage => '$',
		     ] ;
my $StrctSIPHeader = SIPHeader->new() ;

# Variables et constantes du fichier de configuration.
our @TabAuth = () ;
our %TabAdresse = () ;
our %TabUA = () ;
our %TabUAFork = () ;
our $PORT = 0 ;
our $NAME = '' ;
our $ADRESSESRV = '' ;
our $ADRESSEGW = '' ;
our $DOMAINE = '' ;
our $CHAINETAGBRANCH = '' ;
our $NUMCTD = '' ;
our $SECRETCTD = '' ;
our $NOADDNUM = 0 ;
our $ADDNUM = 0 ;
our $NORENVINC = 0 ;
our $RENVINC = 0 ;
#########################################################


require "config.pl" ;
require "Packet.pm" ;
require "Listing.pm" ;
require "pabxFct.pl" ;




# Cration d'un nouveau serveur.
my $server = IO::Socket::INET->new( Proto     => 'udp',
				    LocalPort => $PORT,
				    LocalAddr => $ADRESSESRV) ;
die "[ERROR] Impossible de charger le serveur : $!" unless $server ;
print "[Serveur $0 charg [PID : $$] [UID : $<] [OS : $^O] !]\n" ;


# Dclaration du thread de gestion des tempos.
my $Thr = threads->new(\&TempoControl, \@TabComm, \@TabCommCycleNow, \@TabCommMess, \@TabCommDest, \@TabCommCycleInit, \@TabCommBranchIngress, \@TabCommBranchEgress) ;
# Lancement du thread.
$Thr->detach ;
die "[ERROR] Impossible de lancer le thread de gestion des tempos : $!" unless $Thr ;
print '[Thread de gestion du temps charg !]'."\n" ;

print '[==> Service prt ! <==]'."\n\n" ;




while (1) {
    print ".\n" ;
    
    # Si le fichier "reload" existe, alors regarder s'il reste des communications en cours (en plus du suivi des enregistrements). Si non, redmarrage du programme.
    if( -e './reload') {
	print '[WARN ] Redmarrage demand.\n' ;
	if (scalar(@TabComm) == 0) {
	    print "[WARN ] : Redmarrage lanc.\n" ;
	    unlink('reload') ;
	    system "kill $$ && ./pabx.pl" ;
	}
    } # Fin du "if( -e './reload')"


    # Rceptionner et dcouper le message en un en-tte (qui sera dcoup ensuite en lignes) et en un corps (qui sera dcoup en lignes).
    $server->recv($message, 1500) ;
#    print '[DEBUG] pabx.pl, [Une nouvelle requte !]\n' ; 

    # Protection contre les injections de code
    if ($message =~ /("\.|\.")/ || $message =~ /('\.|\.')/ || $message =~ /\$/) {
	print "[WARN ] Caractre non autoris dans le message ==> paquet rejett\n" ;
	redo ;
    }
    
    # Passage du message  la trononneuse.
    ($DiversComplet, $RefHProxy_Authorization, $RefHCall_ID, $RefHContact, $Content_Type, $Content_Length, $RefHCSeq, $RefHFrom, $RefHMax_Forwards, $Subscription_State, $RefHTo, $RefTabVia, $RefTabRRoute, $RefTabRoute, $RefHLigneEtat, $CorpsMessage) = &Packet_cutHeader($message) ;


#      %HProxy_Authorization = %$RefHProxy_Authorization ;
#      %HCall_ID = %$RefHCall_ID ;
#      %HContact = %$RefHContact ;
#      %HCSeq = %$RefHCSeq ; 
#      %HFrom = %$RefHFrom ;
#      %HTo = %$RefHTo ;
#      @TabVia = @$RefTabVia ;
#      %HMax_Forwards = %$RefHMax_Forwards ;
#      @TabRRoute = @$RefTabRRoute ; 
#      @TabRoute = @$RefTabRoute ;
#      %HLigneEtat = %$RefHLigneEtat ;


#    # Initialisation de la varible structure.
#    $StrctSIPHeader = shift ;

    # Drfrencement des variables rcupres de la fonction et intgration des valeurs dans la variable structure.
    $StrctSIPHeader->DiversComplet($DiversComplet) ;
    $StrctSIPHeader->HProxy_Authorization({%$RefHProxy_Authorization}) ;
    $StrctSIPHeader->HCall_ID({%$RefHCall_ID}) ;
    $StrctSIPHeader->HContact({%$RefHContact}) ;
    $StrctSIPHeader->Content_Type($Content_Type) ;
    $StrctSIPHeader->Content_Length($Content_Length) ;
    $StrctSIPHeader->HCSeq({%$RefHCSeq}) ;
    $StrctSIPHeader->HFrom({%$RefHFrom}) ;
    $StrctSIPHeader->HTo({%$RefHTo}) ;
    $StrctSIPHeader->TabVia([@$RefTabVia]) ;
    $StrctSIPHeader->HMax_Forwards({%$RefHMax_Forwards}) ;
    $StrctSIPHeader->Subscription_State($Subscription_State) ;
    $StrctSIPHeader->TabRRoute([@$RefTabRRoute]) ;
    $StrctSIPHeader->TabRoute([@$RefTabRoute]) ;
    $StrctSIPHeader->HLigneEtat({%$RefHLigneEtat}) ;
    $StrctSIPHeader->CorpsMessage($CorpsMessage) ;

    
    # Protection contre les boucles.
    if (($StrctSIPHeader->HFrom->{'From_Num'} eq $StrctSIPHeader->HTo->{'To_Num'}) and ($StrctSIPHeader->HFrom->{'From_AdrIP'} eq $StrctSIPHeader->HTo->{'To_AdrIP'}) and ($StrctSIPHeader->HLigneEtat->{'Method'} =~ /INVITE/)) {
	print "[WARN ] Appel en boucle dtect donc ignor\n" ;
	redo ;
    }
    # Protection contre les routages infinis (RFC 3261, 8.1.1.6)
    if (($StrctSIPHeader->HMax_Forwards->{'Max_Forwards_Valeur'}) && $StrctSIPHeader->HMax_Forwards->{'Max_Forwards_Valeur'} <= 1) {
	print "[WARN] Max-Forward puis donc paquet ignor\n" ;
	redo ;
    }

    # Donner un numro  la communication si ce n'est dj fait. Evite de devoir travailler avec Call-ID: qui cre des "Out of memory".
    $NumComm = &Listing_findComm($StrctSIPHeader->HCall_ID->{'Call_ID_ID'}) ;
    # Si la communication n'a pas encore t enregistre.
    if ($NumComm == -1) {
	$NumComm = &Listing_addComm($TabAdresse{$StrctSIPHeader->HTo->{'To_Num'}}, $StrctSIPHeader->HTo->{'To_Port'}, $StrctSIPHeader->HCall_ID->{'Call_ID_ID'}) ;
    }

    print "[DEBUG] (Comm. $NumComm) LigneEtat : ".$StrctSIPHeader->HLigneEtat->{'LigneEtat'}."\n" ;
    #   print "Auth : $TabAuth[$NumComm][1] / $TabAuth[$NumComm][2]\n" ;
    
    my $Auth = 'OK' ;

    # SI nous avons un ACK suite  un 401 ou 407, ou que ce n'est pas une requte mais une rponse, on continue.
#    if (($StrctSIPHeader->HLigneEtat->{'Method'} eq 'ACK' && $TabSession[$NumComm] =~ /40[17]/) || $StrctSIPHeader->HLigneEtat->{'Method'} eq '' ) { # Ne fonctionne pas avec les GrandStream
    if (($StrctSIPHeader->HLigneEtat->{'Method'} !~ /(REGISTER|INVITE|BYE)/) || $StrctSIPHeader->HLigneEtat->{'Method'} eq '' ) { # A utiliser avec les tl. GrandStream
	print "[DEBUG] pabx.pl, Pas de ncessit d'authentifier une rponse ou un ACK suite  un 401 ou 407\n" ;
	$Auth = 'OK' ;
    }

    # SI (nous avons une requte ET (que le champ WWW-Authorization est vide ET qu'il y a pourtant un mot de passe pour ce numro)) ALORS demande d'authentification et on termine
    elsif ($StrctSIPHeader->HLigneEtat->{'Method'} && $StrctSIPHeader->HProxy_Authorization->{'Proxy_Authorization'} eq '' && $TabUA{$StrctSIPHeader->HFrom->{'From_Num'}}[1] ne '') {
	print '[DEBUG] pabx.pl, Authentification ncessaire pour '.$StrctSIPHeader->HLigneEtat->{'Method'}.' '.$StrctSIPHeader->HLigneEtat->{'Status_code'}."\n" ;
	$Auth = '407' ;
    }

    # SI les infos d'auth sont prsentes et bonnes, on continue.
    elsif (my $ResultRep = &AuthCalc($StrctSIPHeader->HLigneEtat->{'Method'}, $TabUA{$StrctSIPHeader->HFrom->{'From_Num'}}[1], $StrctSIPHeader->HProxy_Authorization->{'username'}, $StrctSIPHeader->HProxy_Authorization->{'realm'}, $StrctSIPHeader->HProxy_Authorization->{'nc'}, $StrctSIPHeader->HProxy_Authorization->{'nonce'}, $StrctSIPHeader->HProxy_Authorization->{'cnonce'}, $StrctSIPHeader->HProxy_Authorization->{'uri'}, $StrctSIPHeader->HProxy_Authorization->{'qop'})) {

	# SI opaque identiques et rponses aussi, alors authentification OK donc on continue, sinon on renvoie 407 avant de terminer.
	if (($StrctSIPHeader->HProxy_Authorization->{'response'} eq $ResultRep) && ($StrctSIPHeader->HProxy_Authorization->{'opaque'} eq $TabAuth[$NumComm][1])) {
	    print "[DEBUG] pabx.pl, Authorization OK\n" ;
	    $Auth = 'OK' ;
	}
	else {
	    print "[WARN ] pabx.pl, Echec d'authentification\n" ;
#	    print "[DEBUG] pabx.pl, Opaques : $StrctSIPHeader->HProxy_Authorization->{'opaque'} eq $TabAuth[$NumComm][1]\n" ;
#	    print "[DEBUG] &AuthCalc($StrctSIPHeader->HLigneEtat->{'Method'}, $TabUA{$StrctSIPHeader->HFrom->{'From_Num'}}[1], $StrctSIPHeader->HProxy_Authorization->{'username'}, $StrctSIPHeader->HProxy_Authorization->{'realm'}, $StrctSIPHeader->HProxy_Authorization->{'nc'}, $StrctSIPHeader->HProxy_Authorization->{'nonce'}, $StrctSIPHeader->HProxy_Authorization->{'cnonce'}, $StrctSIPHeader->HProxy_Authorization->{'uri'}, $StrctSIPHeader->HProxy_Authorization->{'qop'})\n" ;
#	    print "$StrctSIPHeader->HProxy_Authorization->{'response'} eq $ResultRep\n" ;
	    $Auth = '407' ;    
	}

    }

    # Si nous avons prcdemment demand l'envoi d'un 407, nous l'effectuons maintenant avant de terminer.
    # RFC 3261 22.2 et 22.3 : On envoie un 407 si Proxy SIP demande authentification (avec les champs "Proxy-Authenticate:" pour la requte, "Proxy-Authorization:" pour la rponse). 401 entre 2 terminaux (avec les champs "WWW-Authenticate:" pour la requte et "Authorization:" pour la rponse).
    if ($Auth eq '407') {
	# Rajouter received= au Via: du haut de la pile, rajouter un tag= au To:, ne pas reprendre Contact: et rajouter Proxy-Authenticate:.
	## Composition du Via:
	my $ParaVia = &Packet_viaCompose("rec", $StrctSIPHeader->TabVia,  $server->peerhost(), $server->peerport()) ;
	## Composition du To:
	#my $NouveauTag = &Packet_compoTagBranchNum("t") ;
	$StrctSIPHeader->HTo->{'To'} = $StrctSIPHeader->HTo->{'To'}.";tag=".&Packet_compoTagBranchNum("t") ;
	## Composition du Proxy-Authenticate
	(my $proxy_Authenticate, my $nonce, my $opaque) = AuthGeneration() ;

	$StrctSIPHeader->DiversComplet("Proxy-Authenticate: $proxy_Authenticate\r\n".$StrctSIPHeader->DiversComplet) ;

	# Composition du message 407.
	my $Message407 = &Packet_message4xx('send', $StrctSIPHeader, 0, 0, 'SIP/2.0 407 Proxy Authorization Required') ;
	
# 	# Composition de la rponse 407
# 	my $Message407 = "SIP/2.0 407 Proxy Authorization Required\r
# $ParaVia\r
# $StrctSIPHeader->HFrom->{'From'}\r
# $HTo{'To'}\r
# $HCall_ID{'Call_ID'}\r
# $HCSeq{'CSeq'}\r
# Proxy-Authenticate: $Proxy_Authenticate\r
# $DiversComplet\r
# Content-Length: 0\r
# \r\n" ;

	# Envoi du message
	$server->send($Message407) or die "[ERROR] Erreur lors de l'envoi du Message407 : $!" ;
	# Enregistrement de l'tat de la session
	$TabSession[$NumComm] = '407' ;
	# Enregistrement des paramtres d'authentification
	$TabAuth[$NumComm][1] = $opaque ;
	$TabAuth[$NumComm][2] = $nonce ;
	# Enregistrement de l'tat de l'enregistrement, s'il n'est pas dj en 407.
	if ($TabUA{$StrctSIPHeader->HTo->{'To_Num'}}[2] !~ /407/) {
	    $TabUA{$StrctSIPHeader->HTo->{'To_Num'}}[2] = $TabUA{$StrctSIPHeader->HTo->{'To_Num'}}[2]."_407" ;
	}

	redo ;
    }

    print "[DEBUG] pabx.pl, Authentification passe\n" ;
    ##########################################################################################################################################


    ####################################################
    # Diffrence de traitement selon le type de message.
    if ($StrctSIPHeader->HLigneEtat->{'Method'} eq 'REGISTER') { # Nous sommes en prsence d'un message REGISTER
#	print "[DEBUG] pabx.pl, Entre dans la boucle REGISTER : Numro/Etat avant traitement : $StrctSIPHeader->HTo->{'To_Num'}/$TabUA{$StrctSIPHeader->HTo->{'To_Num'}}[2]\n" ; 
	# S'assurer que les paramtres d'authentification sont indiqus. Si non, on renvoie 401.
	# Si oui, on vrifie l'authentification. Si les paramtres sont OK on enregistre l'inscription ou la dsinscription et on renvoie un OK. Si non, on renvoie 401.
	
#	# S'assurer que les paramtres d'authentification sont donns. Si oui, les vrifier. Si non, rponse 401.
#	my $Auth = '' ;
#
#	if ($HAuthorization{'Authorization'} && $HAuthorization{'cnonce'} && $HAuthorization{'realm'} && $HAuthorization{'uri'} && $HAuthorization{'qop'} && $HAuthorization{'username'} && $HAuthorization{'nc'} && $HAuthorization{'opaque'} && ($HAuthorization{'opaque'} eq $TabAuth[$NumComm][1]) && $HAuthorization{'nonce'} && ($HAuthorization{'nonce'} eq $TabAuth[$NumComm][2]) && $HAuthorization{'response'}) {
#
#	    print "[DEBUG] pabx.pl, my hrep = &AuthCalc ($StrctSIPHeader->HLigneEtat->{'Method'}, $TabUA{$StrctSIPHeader->HFrom->{'From_Num'}}[1], $HAuthorization{'username'}, $HAuthorization{'realm'}, $HAuthorization{'nc'}, $HAuthorization{'nonce'}, $HAuthorization{'cnonce'}, $HAuthorization{'uri'}, $HAuthorization{'qop'}) ;\n" ;

#	    my $hrep = &AuthCalc ($StrctSIPHeader->HLigneEtat->{'Method'}, $TabUA{$StrctSIPHeader->HFrom->{'From_Num'}}[1], $HAuthorization{'username'}, $HAuthorization{'realm'}, $HAuthorization{'nc'}, $HAuthorization{'nonce'}, $HAuthorization{'cnonce'}, $HAuthorization{'uri'}, $HAuthorization{'qop'}) ;
#
# 	    # Comparaison avec ce que le client a envoy. Si identique, rponse OK. Sinon, rponse 401.
# 	    if ($HAuthorization{'response'} eq $hrep) {
	# Enregistrer le demandeur sauf si la valeur de Expires: est 0. A ce moment l, on supprime l'enregistrement.
	(my $expires_Valeur) = $StrctSIPHeader->DiversComplet =~ /Expires: (\d*).*/ ;
	if ($expires_Valeur == 0) {
	    $TabAdresse{$StrctSIPHeader->HTo->{'To_Num'}} = '' ;
	    print '[INFO] ==> Suppression de l\'enregistrement du numro '.$StrctSIPHeader->HTo->{'To_Num'}."\n" ; 
	    # Sauvegarde de l'tat de l'enregistrement.
	    $TabUA{$StrctSIPHeader->HTo->{'To_Num'}}[2] = 'FIN' ;
	}
	else {
	    $TabAdresse{$StrctSIPHeader->HContact->{'Contact_Num'}} = $StrctSIPHeader->HContact->{'Contact_Adr'} ;
	    print '[INFO] ==> Enregistrement du numro '.$StrctSIPHeader->HContact->{'Contact_Num'}."\n" ; 
	    # Enregistrement de l'tat de l'enregistrement.
	    $TabUA{$StrctSIPHeader->HTo->{'To_Num'}}[2] = 'OUI' ;
	}
	
	# Ajout du temps d'expiration au champ Contact:.
	$StrctSIPHeader->HContact->{'Contact'} = $StrctSIPHeader->HContact->{'Contact'}.";expires=$expires_Valeur" ;

# 		# On renvoie un 200 OK
# 		$Auth = "OK" ;
# 	    } # Fin du "if ($response eq $hrep)"
# 	    else {
# 		# On envoie un 401 Unauthorized
# 		$Auth = "401" ;
# 	    }
#	} # Fin de "if ($StrctSIPHeader->HProxy_Authorization->{'Authorization'} && $StrctSIPHeader->HProxy_Authorization->{'cnonce'} && $StrctSIPHeader->HProxy_Authorization->{'realm'} && $StrctSIPHeader->HProxy_Authorization->{'uri'} && $StrctSIPHeader->HProxy_Authorization->{'qop'} && $StrctSIPHeader->HProxy_Authorization->{'username'} && $StrctSIPHeader->HProxy_Authorization->{'nc'} && $StrctSIPHeader->HProxy_Authorization->{'opaque'} && ($StrctSIPHeader->HProxy_Authorization->{'opaque'} eq $TabAuth[$NumComm][1]) && $StrctSIPHeader->Proxy_Authorization->{'nonce'} && ($StrctSIPHeader->HProxy_Authorization->{'nonce'} eq $TabAuth[$NumComm][2]) && $StrctSIPHeader->HProxy_Authorization->{'response'})"
#	else {
#	    $Auth = "401" ;
#	}


	# Authentification correcte, on renvoie un OK.
#	if ($Auth eq "OK") {    
	# Envoyer un OK.
	## Composition du To: : on rajoute un tag=
	my $ToModif = $StrctSIPHeader->HTo->{'To'}.';tag='.&Packet_compoTagBranchNum("t") ;
	$StrctSIPHeader->HTo->{'To'} = $ToModif ;

	# Composition du message OK.
	my $MessageOK = &Packet_messageOK('send', $StrctSIPHeader, $server->peerhost(), $server->peerport()) ;

	## Envoi du message
	$server->send($MessageOK) or die "[ERROR] Erreur lors de l'envoi du MessageOK : $!" ;
	## On garde en mmoire les paramtres pour les rappels d'enregistrement ==> on ne supprime pas les TabSession, TabAuth et autres Tab.
#	}
#
# 	# Si message REGISTER sans authentification, ou que l'authentification est erronne, on (re)lance un challenge.
# 	if (!$Auth || $Auth eq "401") {
# 	    # Rajouter received= au Via: du haut de la pile, rajouter un tag= au To:, ne pas reprendre Contact: et rajouter WWW-Authenticate:.
# 	    ## Composition du Via:
# 	    my $AdresseDistant = $server->peerhost() ;
# 	    my $PortDistant = $server->peerport() ;
# 	    my $ParaVia = &Packet_viaCompose("rec", $StrctSIPHeader->TabVia, $AdresseDistant, $PortDistant) ;
# 	    ## Composition du To:
# 	    my $NouveauTag = &Packet_compoTagBranchNum("t") ;
# 	    $HTo{'To'} = $HTo{'To'}.";tag=$NouveauTag" ;
# 	    ## Composition du WWW-Authenticate
# 	    ($WWW_Authenticate, my $nonce, my $opaque) = AuthGeneration() ;

# 	    # Composition de la rponse 401
# 	    my $Message401 = "SIP/2.0 401 Unauthorized\r
# $ParaVia\r
# $StrctSIPHeader->HFrom->{'From'}\r
# $HTo{'To'}\r
# $HCall_ID{'Call_ID'}\r
# $HCSeq{'CSeq'}\r
# $WWW_Authenticate\r
# $DiversComplet\r
# Content-Length: 0\r
# \r\n" ;

# 	    # Envoi du message
# 	    $server->send($Message401) or die "[ERROR] Erreur lors de l'envoi du Message401 : $!" ;
# 	    # Enregistrement de l'tat de la session
# 	    $TabSession[$NumComm] = "401" ;
# 	    # Enregistrement des paramtres d'authentification
# 	    $TabAuth[$NumComm][1] = $opaque ;
# 	    $TabAuth[$NumComm][2] = $nonce ;
# 	    # Enregistrement de l'tat de l'enregistrement, s'il n'est pas dj en *401.
# 	    if ($TabUA{$StrctSIPHeader->HTo->{'To_Num'}}[2] !~ /401/) {
# 		$TabUA{$StrctSIPHeader->HTo->{'To_Num'}}[2] = $TabUA{$StrctSIPHeader->HTo->{'To_Num'}}[2]."_401" ;
# 	    }
# 	}
	redo ;
    } # Fin du "if ($StrctSIPHeader->HLigneEtat->{'Method'} eq 'REGISTER')"
####
####
    elsif ($StrctSIPHeader->HLigneEtat->{'Method'} =~ /SUBSCRIBE/) { # Nous sommes en prsence d'un message SUBSCRIBE
	# On rpond OK et ensuite on envoie un NOTIFY en indiquant qu'il n'y a pas de message (pour initialiser).
	print "[DEBUG] pabx.pl, Entre dans la boucle SUBSCRIBE\n" ; 
	
	# Composition du message OK
	my $MessageOK = &Packet_messageOK('send', $StrctSIPHeader, $server->peerhost(), $server->peerport()) ;     

	# Envoi du message
	$server->send($MessageOK) or die "[ERROR] Erreur lors de l'envoi du MessageOK : $!" ;
	# Composition du message NOTIFY : on inverse le To: et le From:, on cre le Via: ainsi que le corps du message (et ce qui y est li).
	## On inverse le From: et le To:
	(my $ToModif) = $StrctSIPHeader->HFrom->{'From'} =~ /From: (.*)/ ;
	(my $FromModif) = $StrctSIPHeader->HTo->{'To'} =~ /To: (.*)/ ;
	$StrctSIPHeader->HTo->{'To'} = "To: $ToModif" ;
	$StrctSIPHeader->HFrom->{'From'} = "From: $FromModif" ;
	
	## Composition du message NOTIFY
	#my $NouvelleBranche = &Packet_compoTagBranchNum("b") ;
	#my $NouvelleSeq = &Packet_compoTagBranchNum("n") ;
	## Gnrer le corps du message indiquant qu'il n'y a pas de message (pour initialier) pour ce compte et en calculer la longueur pour le Content-Length:.
	# my $EtatMessagerie = "Messages-Waiting: no\r\nMessage-Account: sip:".$StrctSIPHeader->HTo->{'To_Num'}.'@'.$StrctSIPHeader->HTo->{'To_AdrIP'}."\r\nVoice-Message: 0/0 (0/0)\r\n" ;
	$StrctSIPHeader->CorpsMessage("Messages-Waiting: no\r\nMessage-Account: sip:".$StrctSIPHeader->HTo->{'To_Num'}.'@'.$StrctSIPHeader->HTo->{'To_AdrIP'}."\r\nVoice-Message: 0/0 (0/0)\r\n") ;
	
	# Composition du message.
	my $MessageNOTIFY = &Packet_messageNOTIFY('send', $StrctSIPHeader, , ) ;
	
	#my $Content_Length_Val = length($EtatMessagerie) ;
#	my $MessageNOTIFY = 'NOTIFY sip:'.$StrctSIPHeader->HTo->{'To_Num'}.'@'.$StrctSIPHeader->HTo->{'To_AdrIP'}." SIP/2.0\r
#Via: SIP/2.0/UDP $ADRESSESRV:$PORT;branch=".&Packet_compoTagBranchNum("b")."\r
#From: $FromModif\r
#To: $ToModif\r
#".$StrctSIPHeader->HCall_ID->{'Call_ID'}."\r
#CSeq: ".&Packet_compoTagBranchNum("n")." NOTIFY\r
#".$StrctSIPHeader->DiversComplet."\r
#Subscription-State: active;expires:$Expires_Valeur\r
#Content-Type: application/simple-message-summary\r
#Content-Length: ".length($EtatMessagerie)."\r
#\r
#$EtatMessagerie" ;
	## Envoi du message
	$server->send($MessageNOTIFY) or die "[ERROR] Erreur lors de l'envoi du MessageNOTIFY : $!" ;
	# Enregistrement de l'tat de la session.
	$TabSession[$NumComm] = "NOTIFY" ;
	redo ;
    } # Fin du "elsif ($StrctSIPHeader->HLigneEtat->{'Method'} =~ /SUBSCRIBE/)"
####
####
    elsif ((my $NotifyNum, my $NotifyAdr, my $NotifyPort) = $StrctSIPHeader->HLigneEtat->{'LigneEtat'} =~ /NOTIFY sip:(.*)\@(\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}):?(\d*)?(?:;.*)* SIP\/2\.0/) { # Nous sommes en prsence d'un message NOTIFY
	print "[DEBUG] pabx.pl, Entre dans la boucle NOTIFY\n" ; 
	
	# Si aucun port n'est indiqu, on utilise le port par dfaut qui est le 5060.
	if (!$NotifyPort) {$NotifyPort = 5060 ;}
	
	# Vrifier si le message ne vient d'un Clic-To-Dial hberg sur la machine. Si c'est le cas, on rpond OK au lieu de faire suivre (sinon on se l'enverrait en boucle infiniment).
	if ($NotifyAdr eq $ADRESSESRV && $NotifyPort == $PORT) {
# 	    # On ne change rien au paragraphe Via: reu dans le NOTIFY.
# 	    my $ParaVia = &Packet_viaCompose("none", $StrctSIPHeader->TabVia, 0, 0) ;
# 	    print "TEST ATTENTION BOUCLE\n" ;
# 	    my $MessageOK = "SIP/2.0 200 OK\r
# $ParaVia\r
# $StrctSIPHeader->HFrom->{'From'}\r
# $HTo{'To'}\r
# $HCall_ID{'Call_ID'}\r
# $HCSeq{'CSeq'}\r
# $HContact{'Contact'}\r
# Max-Forwards: 70\r
# $DiversComplet\r
# Content-Length: 0\r
# \r\n" ;

# 	    # Envoi du message.
# 	    $server->send($MessageOK) or die "[ERROR] Erreur lors de l'envoi du MessageOK : $!" ;
# 	    print "[DEBUG] Envoi du message OK  un NOTIFY  destination du Proxy SIP\n" ;
	    
# 	    # On ferme cette session.
# 	    &Listing_delComm($NumComm) ;
	}
	else {
	    
	    # On fait suivre le message  l'adresse indique dans la ligne d'tat et en se rajoutant dans la pile de Via:
	    
	    # Composition du message.
	    my $MessageNOTIFY = &Packet_messageNOTIFY('forward', $StrctSIPHeader, $server->peerhost(), $server->peerport()) ;
	    
	    ## Composition du paragraphe Via:
	    # my $ParaVia = &Packet_viaCompose('ajout', $StrctSIPHeader->TabVia, $server->peerhost(), $server->peerport()) ;
	    
	    ## On garde le paragraphe Route: comme il est.
	    #  my $ParaRoute = join("\r\n", @{$StrctSIPHeader->TabRoute}) ;
	    ## Composition du message
	    # my $MessageNOTIFY = $StrctSIPHeader->HLigneEtat->{'LigneEtat'}."\r
#$ParaVia\r
#$ParaRoute
#".$StrctSIPHeader->HFrom->{'From'}."\r
#".$StrctSIPHeader->HTo->{'To'}."\r
#".$StrctSIPHeader->HCall_ID->{'Call_ID'}."\r
#".$StrctSIPHeader->HCSeq->{'CSeq'}."\r
#Max-Forwards: ".($StrctSIPHeader->HMax_Forwards->{'Max_Forwards_Valeur'} - 1)."\r
#".$StrctSIPHeader->DiversComplet."\r
#".$StrctSIPHeader->Content_Type."\r
#".$StrctSIPHeader->Content_Length."\r
#\r
#".$StrctSIPHeader->CorpsMessage ;	
	    # Crer un socket vers le saut suivant
	    # Si aucun port n'est indiqu, on utilise le port par dfaut qui est le 5060.
	    if (!$NotifyPort) {$NotifyPort = 5060 ;}
	    my $client = IO::Socket::INET->new( Proto     => 'udp',
						PeerPort  => $NotifyPort,
						PeerAddr  => $NotifyAdr) ;
	    die "[ERROR] Impossible de charger le client10 : $!" unless $client ;
	    ## Envoi de la rponse
	    $client->send($MessageNOTIFY) if ($client && $NotifyPort && $NotifyAdr) or die "[ERROR] Erreur lors de l'envoi du MessageNOTIFY : $!" ;
	    ## Enregistrement de l'tat de la session.
	    $TabSession[$NumComm] = 'NOTIFY' ;
	    # Rarmer le timer (4 cycles) pour cette communication.
	    &Listing_addTime($NumComm, 4, $MessageNOTIFY, "/udp/$NotifyAdr/$NotifyPort/") ;
	    ## Fermeture du client.
	    close ($client) ;
	}
	redo ;
    } # Fin du "elsif ((my $NotifyAdr, my $NotifyPort) = $StrctSIPHeader->HLigneEtat->{'LigneEtat'} =~ /NOTIFY sip:.*\@(\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}):?(\d*)?(?:;.*)* SIP\/2\.0/)"
####
####
    elsif (($StrctSIPHeader->HLigneEtat->{'Method'} eq 'INVITE') and ($StrctSIPHeader->HLigneEtat->{'Request_URI'}) =~ /sip:[^\*].*/) { # Nous sommes en prsence d'un message INVITE
	print "[DEBUG] pabx.pl, Entre dans la boucle INVITE\n" ; 
	# Rpondre Trying, rechercher o se trouve l'appell pour ensuite lui faire suivre le message INVITE que l'on aura modifi
	# Message Trying
	my $AdresseDistant = $server->peerhost() ;
	my $PortDistant = $server->peerport() ;

	my $MessageTrying = &Packet_messageTrying('send', $StrctSIPHeader, $AdresseDistant, $PortDistant) ;

	## Envoi de la rponse provisoire
	$server->send($MessageTrying) or die "[ERROR] Erreur lors de l'envoi du MessageTrying : $!" ;
	## Enregistrer la tentative dans le fichier de taxation.
	&Taxation('try', ''.$StrctSIPHeader->HFrom->{'From_Num'}.'@'.$StrctSIPHeader->HFrom->{'From_AdrIP'}, ''.$StrctSIPHeader->HTo->{'To_Num'}.'@'.$StrctSIPHeader->HTo->{'To_AdrIP'}) ;


 	my $ParaVia = &Packet_viaCompose('rec', $StrctSIPHeader->TabVia, $AdresseDistant, $PortDistant) ;
	
	# Vrification de la discri et choix de l'adresse de destination par LCR.
	my $ProchainSaut = &LCR_Discri($StrctSIPHeader->HFrom->{'From_Num'}, $StrctSIPHeader->HTo->{'To_Num'}) ;
	print "[DEBUG] pabx.pl, prochain saut par LCR_Discri : $ProchainSaut\n" ; 
	if ($ProchainSaut ne 'INTERDIT' && $ProchainSaut ne 'NOTFOUND') {
	    # Message INVITE 
	    ## Composition du paragraphe Via: : on insre un Via: en haut de pile avec l'adresse du serveur et une branche puis on rajoute un received= au second (dj fait ci-dessus).
#	    $NouvelleBranche = &Packet_compoTagBranchNum("b") ;
	    #  $ParaVia = &Packet_viaCompose('ajout', $StrctSIPHeader->TabVia, $AdresseDistant, $PortDistant) ;
	    
	    #  # Rcuprer la branche.
	    #  ($TabCommBranchEgress[$NumComm]) = $ParaVia =~ /branch=([^;\s]*)/ ;
	    
	    ## Si on est capable de rediriger le flux vers le destinataire, alors modifier la ligne d'tat avec l'adresse IP du destinataire.
	    if ($TabAdresse{$StrctSIPHeader->HTo->{'To_Num'}}) {
		## On connait l'adresse IP du destinataire.
		$StrctSIPHeader->HLigneEtat->{'LigneEtat'} = 'INVITE sip:'.$StrctSIPHeader->HTo->{'To_Num'}.'@'.$TabAdresse{$StrctSIPHeader->HTo->{'To_Num'}}.' SIP/2.0' ;
	    }
#	    ## Composition du paragraphe Record-Route: : on rajoute le serveur en haut de la pile.
#	    unshift(@TabRRoute, "Record-Route: <sip:$ADRESSESRV;lr>") ;
#	    my $ParaRRoute = join("\r\n", @TabRRoute) ;
	    
	    # Rcuprer la branche entrante.
	    ($TabCommBranchIngress[$NumComm]) = $StrctSIPHeader->TabVia->[0] =~ /branch=([^;\s]*)/ ;
	    
	    # Composer le message INVITE  faire suivre.
	    my $MessageINVITE = &Packet_messageINVITE('forward', $StrctSIPHeader, $AdresseDistant, $PortDistant, 0) ;

	    # Rcuprer la branche sortante.
	    ($TabCommBranchEgress[$NumComm]) = $MessageINVITE =~ /branch=([^;\s]*)/ ;

	    ## Crer un autre socket vers le saut suivant.
	    # Si aucun port n'est indiqu, on utilise le port par dfaut qui est le 5060.
	    if (!$StrctSIPHeader->HTo->{'To_Port'}) {
		$StrctSIPHeader->HTo->{'To_Port'} = 5060 ;
	    }
	    my $client = IO::Socket::INET->new( Proto     => 'udp',
						PeerPort  => $StrctSIPHeader->HTo->{'To_Port'},
						PeerAddr  => $ProchainSaut) ;
	    die "[ERROR] Impossible de charger le client1 : $!" unless $client ;
	    ## Envoi du message
	    $client->send($MessageINVITE) if ($client && $StrctSIPHeader->HTo->{'To_Port'} && $ProchainSaut)or die "[ERROR] Erreur lors de l'envoi du MessageINVITE : $!" ;
	    ## Fermeture du client.
	    close($client) ;

	    # Si le poste appell est dans un groupement de poste, alors traitement particulier.
	    if ($TabUA{$StrctSIPHeader->HTo->{'To_Num'}}[5] != 0) {
		# Initialisation des suivis pour le numro appell.
		for (my $compteur = 20; $compteur < 30; $compteur ++) {
		    $TabUAFork{$StrctSIPHeader->HTo->{'To_Num'}}[$compteur] = 0 ;
		}
		
		# The CANCEL state line is the same than the INVITE state line except the method name.
		$StrctSIPHeader->HLigneEtat->{'LigneEtat'} =~ s/INVITE/CANCEL/ ;

		my $MessageCANCEL = &Packet_messageCANCEL('send', $StrctSIPHeader, 0, 0, 0) ;
		$TabUAFork{$StrctSIPHeader->HTo->{'To_Num'}}[1] = $MessageCANCEL ;

# 		# Cration du message CANCEL : On garde tous les champs de l'INVITE sauf la ligne d'tat, le CSeq que l'on modifie, le Max-Forwards qui passe  70 et le Content-Legth  0 puisqu'il n'y a pas de corps de message.
# 		my $MessageCANCELHead = "$ParaVia\r
# $StrctSIPHeader->HFrom->{'From'}\r
# $HTo{'To'}\r
# $ParaRRoute\r
# $HCall_ID{'Call_ID'}\r
# CSeq: $HCSeq{'CSeq_Num'} CANCEL\r
# Max-Forwards: 70\r
# $DiversComplet\r
# Content-Length: 0\r
# \r\n" ;
#		$TabUAFork{$HTo{'To_Num'}}[1] = $MessageCANCELHead ;
		
		# Suivant le mode de gestion des appels sur le groupement de postes, on va faire un traitement diffrent.
		if ($TabUA{$StrctSIPHeader->HTo->{'To_Num'}}[5] == 1) {
		    print "[DEBUG] pabx.pl, Groupement de poste actif avec appels de tous les postes en mme temps\n" ; 
		    # Mode find-me, c'est--dire que tous les postes sont sonns en mme temps.
		    for (my $compteur = 10; $compteur < 20; $compteur ++) {
			if ($TabUAFork{$StrctSIPHeader->HTo->{'To_Num'}}[$compteur] ne '') {
			    
			    # Ouvrir socket
			    (my $adresse, my $port) = $TabUAFork{$StrctSIPHeader->HTo->{'To_Num'}}[$compteur] =~ /(\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}):(\d*)/ ;
			    my $client = IO::Socket::INET->new( Proto     => 'udp',
								PeerPort  => $port,
								PeerAddr  => $adresse) ;
			    die "[ERROR] Impossible de charger le client12 : $!" unless $client ;
			    
			    # Envoi du message INVITE
			    #my $MessageINVITE = "INVITE sip:$StrctSIPHeader->HTo->{'To_Num'}\@$adresse:$port SIP/2.0\r\n".$MessageINVITEHead ;
			    
			    $StrctSIPHeader->HLigneEtat->{'Ligne_Etat'} = 'INVITE sip:'.$StrctSIPHeader->HTo->{'To_Num'}."\@$adresse:$port SIP/2.0" ;
			    my $MessageINVITE = &Packet_messageINVITE('forward', $StrctSIPHeader, $AdresseDistant, $PortDistant, 0) ;
			    
			    
			    
			    $client->send($MessageINVITE) if ($client && $port && $adresse) or die "[ERROR] Erreur lors de l'envoi du MessageINVITE (find-me) : $!" ;
			    print "[DEBUG] pabx.pl, INVITE envoy au $adresse:$port\n" ; 
			    
			    # Fermeture du socket
			    close($client) ;
			    
			    # Enregistrement du suivi.
			    $TabUAFork{$StrctSIPHeader->HTo->{'To_Num'}}[$compteur + 10] = 1 ;
			} # Fin du "if ($TabUAFork{$StrctSIPHeader->HTo->{'To_Num'}}[$compteur])"
		    } # Fin du "for (my $compteur = 10; $compteur < 20; $compteur ++)"
		} # Fin du "if ($TabUA{$StrctSIPHeader->HTo->{'To_Num'}}[5] == 1)"
	    } # Fin du "if ($TabUA{$StrctSIPHeader->HTo->{'To_Num'}}[5] != 0)"

	    # Enregistrement de l'tat de la session et mise  jour du listing.
	    $TabSession[$NumComm] = "Trying" ;
	    $TabCommMess[$NumComm] = $MessageINVITE ;
	    $TabCommDest[$NumComm] = "/udp/$ProchainSaut/".$StrctSIPHeader->HTo->{'To_Port'}."/" ;
	} # Fin du if ($ProchainSaut ne "INTERDIT" && $ProchainSaut ne "NOTFOUND").
	elsif ($ProchainSaut eq 'INTERDIT') {
	    ## La demande d'appel est interdite par la discrimination. Envoyer un message d'erreur 401.

	    my $MessageUNAUTHORIZED = &Packet_message4xx('send', $StrctSIPHeader, 0, 0, 'SIP/2.0 401 Unauthorized') ;
	    
# 	    ## Composition du message
# 	    my $MessageUNAUTHORIZED = "SIP/2.0 401 Unauthorized\r
# $ParaVia\r
# $StrctSIPHeader->HFrom->{'From'}\r
# $HTo{'To'}\r
# $HCall_ID{'Call_ID'}\r
# $HCSeq{'CSeq'}\r
# $DiversComplet\r
# Content-Length: 0\r
# \r\n" ;
	    ## Envoi de la rponse
	    $server->send($MessageUNAUTHORIZED) or die "[ERROR] Erreur lors de l'envoi du MessageUNAUTHORIZED : $!" ;
	    print '[WARN ] Le numro '.$StrctSIPHeader->HTo->{'To_Num'}.' depuis '.$StrctSIPHeader->HFrom->{'From_Num'}." est interdit : Renvoi d'un message 401 Unauthorized\n" ;
	    # Enregistrements divers pour le suivi de la communication.
	    $TabSession[$NumComm] = "401" ;
	    $TabCommMess[$NumComm] = $MessageUNAUTHORIZED ;
	    $TabCommDest[$NumComm] = "/udp/".$server->peerhost()."/".$server->peerport()."/" ;
	}
	else {
	    ## Ce numro n'est pas explicitement interdit et l'on n'a pas trouv  qui correspond ce numro. Envoyer un message d'erreur 404.
            # 8.2.2.1, RFC 3261 : If the Request-URI uses a scheme not supported by the UAS, it SHOULD reject the request with a 416 (Unsupported URI Scheme)response. If the Request-URI does not identify an address that the UAS is willing to accept requests for, it SHOULD reject the request with a 404 (Not Found) response.
	    if ($StrctSIPHeader->HTo->{'To'} !~ /sip:/) {
		
		my $MessageUnsupportedURIScheme = &Packet_message4xx('send', $StrctSIPHeader, 0, 0,'SIP/2.0 406 Unsupported URI Scheme') ;

# 		## Composition du message 406
# 		my $MessageUnsupportedURIScheme = "SIP/2.0 406 Unsupported URI Scheme\r
# 		$ParaVia\r
# 		$StrctSIPHeader->HFrom->{'From'}\r
# 		$HTo{'To'}\r
# 		$HCall_ID{'Call_ID'}\r
# 		$HCSeq{'CSeq'}\r
# 		$DiversComplet\r
# 		Content-Length: 0\r
# 		\r\n" ;
		## Envoi de la rponse
		$server->send($MessageUnsupportedURIScheme) or die "[ERROR] Erreur lors de l'envoi du MessageUnsupportedURIScheme : $!" ;
		print '[WARN ] Le schma URI '.$StrctSIPHeader->HTo->{'To'}." n'est par support : Renvoi d'un message 406 Unsupported URI Scheme\n" ;
		$TabSession[$NumComm] = "406" ; 
		$TabCommMess[$NumComm] = $MessageUnsupportedURIScheme ;
		$TabCommDest[$NumComm] = "/udp/".$server->peerhost()."/".$server->peerport()."/" ;
	    }
	    else {
		
		my $MessageNOTFOUND = &Packet_message4xx('send', $StrctSIPHeader, 0, 0, 'SIP/2.0 404 Not Hound') ;

# 		## Composition du message 404
# 		my $MessageNOTFOUND = "SIP/2.0 404 Not Found\r
# $ParaVia\r
# $StrctSIPHeader->HFrom->{'From'}\r
# $HTo{'To'}\r
# $HCall_ID{'Call_ID'}\r
# $HCSeq{'CSeq'}\r
# $DiversComplet\r
# Content-Length: 0\r
# \r\n" ;
		## Envoi de la rponse
		$server->send($MessageNOTFOUND) or die "[ERROR] Erreur lors de l'envoi du MessageNOTFOUND : $!" ;
		print 'Le numro '.$StrctSIPHeader->HTo->{'To_Num'}." n'a pu tre trouv : Renvoi d'un message 404 Not Found\n" ;
		$TabSession[$NumComm] = "404" ; 
		$TabCommMess[$NumComm] = $MessageNOTFOUND ;
		$TabCommDest[$NumComm] = "/udp/".$server->peerhost()."/".$server->peerport()."/" ;
	    }
	}
	redo ;
    } # Fin du "elsif (($StrctSIPHeader->HLigneEtat->{'Method'} eq 'INVITE') and ($StrctSIPHeader->HLigneEtat->{'Request_URI'}) =~ /sip:[^\*].*/)"
####
####
    elsif ($StrctSIPHeader->HLigneEtat->{'Status_code'} eq '100') { # Nous sommes en prsence d'une rponse provisoire Trying
	# On en fait rien.
	print "[DEBUG] pabx.pl, Entre dans la boucle Trying\n" ; 
	# On ne modifie pas l'tat de la session car soit on est dj en INVITE, soit on est dans un tat plus avanc (groupement de postes) et donc on ne met pas un tat plus ancien.
	# Rarmer le timer pour cette communication.
	&Listing_addTime($NumComm, 4, 0, 0) ;
	# Enregistrement de l'tat de la session.
	$TabSession[$NumComm] = 'Trying' ;
	redo ;
    } # Fin du "elsif ($StrctSIPHeader->HLigneEtat->{'Status_code'} eq '100')"
####    
####    
    elsif ($StrctSIPHeader->HLigneEtat->{'Status_code'} eq '180') { # Nous sommes en prsence d'une rponse provisoire 180 Ringing
	print "[DEBUG] pabx.pl, Entre dans la boucle Ringing\n" ; 
	# Recherche de l'adresse  qui envoyer le Ringing (c'est celle indique dans le 2ime Via: en partant du haut de la pile).
	my $Adresse = '' ;
	my $Port = '' ;
	if ($StrctSIPHeader->TabVia->[1] =~ /;received=/) {
	    ($Adresse) = $StrctSIPHeader->TabVia->[1] =~ /received=(\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3})/ ;
	    ($Port) = $StrctSIPHeader->TabVia->[1] =~ /rport=(\d*)/ ;
	}
	else {
	    ($Adresse, $Port) = $StrctSIPHeader->TabVia->[1] =~ /Via: SIP\/2\.0\/(?:UDP|TCP|SCTP) (\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}):?(\d*)?.*/ ;
	}
	
	my $MessageRinging = &Packet_messageRinging('forward', $StrctSIPHeader, 0, 0) ;
	
	# Crer un autre socket vers le saut suivant
	# Si aucun port n'est indiqu, on utilise le port par dfaut qui est le 5060.
	if (!$Port) {$Port = 5060 ;}
	my $client = IO::Socket::INET->new( Proto    => 'udp',
					    PeerPort => $Port,
					    PeerAddr => "$Adresse") ;
	die "[ERROR] Impossible de charger le client2 : $!" unless $client ;

	# Envoi du message
	$client->send($MessageRinging) if ($client && $Port && $Adresse) or die "[ERROR] Erreur lors de l'envoi du MessageRinging : $!" ;
	# Enregistrement de l'tat de la session si nous sommes dans un tat Trying.
	if ($TabSession[$NumComm] eq 'Trying') {
	    $TabSession[$NumComm] = 'Ringing' ;
	}
	# Rarmer le timer pour cette communication. On garde toujours le message INVITE en mmoire.
	&Listing_addTime($NumComm, 120, 0, 0) ;
	# Fermeture du client.
	close($client) ;
	redo ;
    } # Fin du "elsif ($StrctSIPHeader->HLigneEtat->{'Status_code'} eq '180')"
####
####
    elsif ($StrctSIPHeader->HLigneEtat->{'Status_code'} eq '200' and ($StrctSIPHeader->HCSeq->{'CSeq'} !~ /CANCEL/) and ($StrctSIPHeader->HCSeq->{'CSeq'} !~ /INFO/)) { # Nous sommes en prsence d'un message OK suite  un BYE, un NOTIFY ou un INVITE, mais pas d'un CANCEL ou un INFO.
	print "[DEBUG] pabx.pl,Entre dans la boucle OK suite  un BYE, NOTIFY ou INVITE (Ringing) : $TabSession[$NumComm]\n" ; 
	# Recherche de l'adresse  qui envoyer le OK (c'est celle indique dans le 2ime Via: en partant du haut de la pile).
	my $Adresse = '' ;
	my $Port = '' ;
	if ($StrctSIPHeader->TabVia->[1] =~ /;received=/) {
	    ($Adresse) = $StrctSIPHeader->TabVia->[1] =~ /received=(\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3})/ ;
	    ($Port) = $StrctSIPHeader->TabVia->[1] =~ /rport=(\d*)/ ;
	}
	else {
	    ($Adresse, $Port) = $StrctSIPHeader->TabVia->[1] =~ /Via: SIP\/2\.0\/(?:UDP|TCP|SCTP) (\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}):?(\d*)?.*/ ;
	}
	# Enlever le Via: du haut de la pile et envoyer  la machine indique dans le second Via: (adresse rcupre ci-dessus).
	## Composition du paragraphe Via:
	my $ParaVia = &Packet_viaCompose('suppr', $StrctSIPHeader->TabVia, 0, 0) ;
	# Si OK suite  un INVITE, quelques spcificits : le paquet n'est pas le mme (Record-Route:, Content-Type:, Content-Length:, corps message).

	my $MessageOK = &Packet_messageOK('forward', $StrctSIPHeader, 0, 0) ;

	## Crer un autre socket vers le saut suivant s'il existe
	# Si aucun port n'est indiqu, on utilise le port par dfaut qui est le 5060.
	if (!$Port) {$Port = 5060 ;}
	if ($Adresse ne '') {
	    my $client = IO::Socket::INET->new( Proto    => 'udp',
						PeerPort => $Port,
						PeerAddr => $Adresse) ;
	    die "[ERROR] Impossible de charger le client4 : $!" unless $client ;
	    ## Envoi du message
	    $client->send($MessageOK) if ($client && $Port && $Adresse) or die "[ERROR] Erreur lors de l'envoi du MessageOK : $!" ;
	    
	    # Fermeture du client.
	    close ($client) ;
	}
	# Enregistrement de l'tat de la session.
	$TabSession[$NumComm] = 'OK_'.$StrctSIPHeader->HCSeq->{'CSeq_Type'} ;
	# Chercher dans le listing la communication et la supprimer si c'est un OK suite  un BYE (comm. termine). Si c'est suite  un INVITE, donner 14400 cycles car on n'attend plus rien normalement. Pour OK suite  INVITE ou BYE, mettre un message pour la taxation.
	if ($StrctSIPHeader->HCSeq->{'CSeq_Type'} =~ /INVITE/) {
	    &Listing_addTime($NumComm, 14400, 0, 0) ;
	    # Taxation.
	    &Taxation('new', ''.$StrctSIPHeader->HFrom->{'From_Num'}.'@'.$StrctSIPHeader->HFrom->{'From_AdrIP'}, ''.$StrctSIPHeader->HTo->{'To_Num'}.'@'.$StrctSIPHeader->HTo->{'To_AdrIP'}) ;

	    # Si le numro fait partie d'un groupement de poste, alors envoyer un CANCEL  tous les postes en cours de sollicitation.
	    if ($TabUA{$StrctSIPHeader->HTo->{'To_Num'}}[5] != 0) {

		my $AdresseDistant = $server->peerhost() ;
		my $PortDistant = $server->peerport() ;
		for (my $compteur = 10; $compteur < 20; $compteur ++) {
		    # Pour chaque lment de la liste, regarder si c'est le poste qui a rpondu OK. Si oui, affecter son adresse IP au numro du poste initialement appel, puis plus de suivi. Si non, plus de suivi et envoi d'un CANCEL.
		    if ($TabUAFork{$StrctSIPHeader->HTo->{'To_Num'}}[$compteur] eq "$AdresseDistant:$PortDistant") {
			# Affecter l'adresse IP qui a rpondu au numro du poste initialement appel.
			$TabAdresse{$StrctSIPHeader->HTo->{'To_Num'}} = $AdresseDistant ;
			# Plus de suivi.
			$TabUAFork{$StrctSIPHeader->HTo->{'To_Num'}}[$compteur + 10] = 2 ;
		    }
		    elsif(($TabUAFork{$StrctSIPHeader->HTo->{'To_Num'}}[$compteur] ne '') && ($TabUAFork{$StrctSIPHeader->HTo->{'To_Num'}}[$compteur + 10] = 1) && ($TabUAFork{$StrctSIPHeader->HTo->{'To_Num'}}[$compteur] ne "$AdresseDistant:$PortDistant")) {
			# Ouvrir socket
			(my $adresse, my $port) = $TabUAFork{$StrctSIPHeader->HTo->{'To_Num'}}[$compteur] =~ /(\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}):(\d*)/ ;
			my $client = IO::Socket::INET->new( Proto     => 'udp',
							    PeerPort  => $port,
							    PeerAddr  => $adresse) ;
			die "[ERROR] Impossible de charger le client14 : $!" unless $client ;
			
			# Envoi du message CANCEL
#			my $MessageCANCEL = "CANCEL sip:$StrctSIPHeader->HTo->{'To_Num'}\@$adresse:$port SIP/2.0\r\n".$TabUAFork{$StrctSIPHeader->HTo->{'To_Num'}}[1] ;
			my $MessageCANCEL = $TabUAFork{$StrctSIPHeader->HTo->{'To_Num'}}[1] ;
			$client->send($MessageCANCEL) if ($client && $port && $adresse) or die "[ERROR] Erreur lors de l'envoi du MessageCANCEL (find-me) : $!" ;
			
			# Fermeture du socket
			close($client) ;
			
			$TabUAFork{$StrctSIPHeader->HTo->{'To_Num'}}[$compteur + 10] = 2 ;
		    } # Fin du "$TabUAFork{$StrctSIPHeader->HTo->{'To_Num'}}[$compteur] ne '' && $TabUAFork{$StrctSIPHeader->HTo->{'To_Num'}}[$compteur + 10] = 1 && $TabUAFork{$StrctSIPHeader->HTo->{'To_Num'}}[$compteur] ne "$AdresseDistant:$PortDistant''
		} # Fin du "for (my $compteur = 10; $compteur < 20; $compteur ++)"
	    } # Fin du "if ($TabUA{$StrctSIPHeader->HTo->{'To_Num'}}[5] != 0)"

	}	
	elsif ($StrctSIPHeader->HCSeq->{'CSeq_Type'} =~ /BYE/) {
	    &Listing_delComm($NumComm) ;
	    delete($TabSession[$NumComm]) ; 
	    # Taxation
	    &Taxation('end', ''.$StrctSIPHeader->HFrom->{'From_Num'}.'@'.$StrctSIPHeader->HFrom->{'From_AdrIP'}, ''.$StrctSIPHeader->HTo->{'To_Num'}.'@'.$StrctSIPHeader->HTo->{'To_AdrIP'}) ;
	}
	elsif ($StrctSIPHeader->HCSeq->{'CSeq_Type'} =~ /NOTIFY/) {
	    &Listing_delComm($NumComm) ;
	    delete($TabSession[$NumComm]) ;
	}
	
	redo ;
    } # Fin "elsif ($StrctSIPHeader->HLigneEtat->{'Status_code'} eq '200' and ($StrctSIPHeader->HCSeq->{'CSeq'} !~ /CANCEL/) and ($StrctSIPHeader->HCSeq->{'CSeq'} !~ /INFO/))"
####
####
# new ! :je pense que l'on peut dire que c'est le ACK de tout sauf des erreurs 4xx
    elsif ($StrctSIPHeader->HLigneEtat->{'Method'} eq 'ACK' and (($TabSession[$NumComm] =~ 'OK_INVITE') or ($TabSession[$NumComm] =~ /60\d/))) { # Nous sommes en prsence d'un message ACK suite  un 60x ou  un OK d'un INVITE.
	print "[DEBUG] pabx.pl, Entre dans la boucle ACK suite  un 60x ou  un OK d'un INVITE : $TabSession[$NumComm]\n" ;
	# Composition du paragraphe Via:. Rajouter received= au Via du haut de la pile, insrer un autre Via: pour le serveur.
	my $ParaVia = &Packet_viaCompose('ajout', $StrctSIPHeader->TabVia, $server->peerhost(), $server->peerport()) ;
	# On enlve la route du haut (c'est nous !) et on laisse les autres routes. S'il n'y a alors plus de route, il faudra enlever cette option de la composition du paquet.
	shift(@{$StrctSIPHeader->TabRoute}) ;
	my $ParaRoute = join("\r\n", @{$StrctSIPHeader->TabRoute}) ;

	my $MessageACK = &Packet_messageACK('forward', $StrctSIPHeader, $server->peerhost(), $server->peerport()) ;

	# Crer un socket vers le saut suivant
	my $AdresseClient = '' ;
	my $PortClient = '' ;
	if (scalar(@{$StrctSIPHeader->TabRoute}) > 1) {
	    ($AdresseClient, $PortClient) = $StrctSIPHeader->TabRoute->[1] =~ /.*sip\:(\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}):?(\d*)?.*/ ;
	}
	else {
	    $AdresseClient = &LCR_Discri($StrctSIPHeader->HFrom->{'From_Num'}, $StrctSIPHeader->HTo->{'To_Num'}) ;
	}
	# Si aucun port n'est indiqu, on utilise le port par dfaut qui est le 5060.
	if (!$PortClient) {$PortClient = 5060 ;}
	my $client = IO::Socket::INET->new( Proto     => 'udp',
					    PeerPort  => $PortClient,
					    PeerAddr  => $AdresseClient) ;
	die "[ERROR] Impossible de charger le client8 : $!" unless $client ;
	# Envoi du message
	$client->send($MessageACK) if ($client && $PortClient && $AdresseClient) or die "[ERROR] Erreur lors de l'envoi du MessageACK : $!" ;
	# Fermeture du client.
	close ($client) ;	
	
	# Si c'tait une rponse  un INVITE, alors on suit la session et on recharge le timer, sinon on efface tout.
	if ($TabSession[$NumComm] eq 'OK_INVITE') {
	    # Enregistrement de l'tat de la session.
	    $TabSession[$NumComm] = 'ACK_OK' ;
	    # On donne 14400 cycles de communication (2h si un cycle est gal  0,5s).
	    &Listing_addTime($NumComm, 14400, 0, 0) ;
	}
	else {
	    &Listing_delComm($NumComm) ;
	}
	
	redo ;
    } # Fin du "elsif ($StrctSIPHeader->HLigneEtat->{'Method'} eq 'ACK' and (($TabSession[$NumComm] =~ 'OK_INVITE') or ($TabSession[$NumComm] =~ /60\d/)))"
####
####
    elsif ($StrctSIPHeader->HLigneEtat->{'Method'} eq 'BYE') { # Nous sommes en prsence d'un message BYE
	print "[DEBUG] pabx.pl, Entre dans la boucle BYE\n" ; 

	# Rcuprer la branche entrante.
	($TabCommBranchIngress[$NumComm]) = $StrctSIPHeader->TabVia->[0] =~ /branch=([^;\s]*)/ ;

	# Composer le message BYE  faire suivre.
	my $MessageBYE = &Packet_messageBYE('forward', $StrctSIPHeader, $server->peerhost(), $server->peerport(), 0) ;

	# Rcuprer la branche sortante.
	($TabCommBranchEgress[$NumComm]) = $MessageBYE =~ /branch=([^;\s]*)/ ;

	## Crer un socket vers le saut suivant
# Code ci-dessous comment car peut poser pb. TEST : vrifier sa validit.
	my $AdresseClient = '' ;
	my $PortClient = '' ;
#	if (scalar(@TabRoute) >= 1) {
#	    ($AdresseClient, $PortClient) = $TabRoute[0] =~ /.*sip\:(\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}):?(\d*)?.*/ ;
#	}
#	else {
	# Une mauvaise implmentation SIP dans les GrandStream ne nous permet pas d'utiliser cela.
	($AdresseClient, $PortClient) = $StrctSIPHeader->HLigneEtat->{'Request_URI'} =~ /.*\@(\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}):?(\d*)?.*/ ;
# TEST : cf commentaire 2 lignes au-dessus.
#	($AdresseClient, $PortClient) = $StrctSIPHeader->HTo->{'To'} = /sip:(.*)\@(\S*)>/ ;

#	}
	# Si aucun port n'est indiqu, on utilise le port par dfaut qui est le 5060.
	if (!$PortClient) {$PortClient = 5060 ;}
	my $client = IO::Socket::INET->new( Proto     => 'udp',
					    PeerPort  => $PortClient,
					    PeerAddr  => $AdresseClient) ;
	die "[ERROR] Impossible de charger le client6 : $!" unless $client ;
	## Envoi du message
	$client->send($MessageBYE) if ($client && $PortClient && $AdresseClient) or die "[ERROR] Erreur lors de l'envoi du MessageBYE : $!" ;
	## Enregistrement de l'tat de la session.
	$TabSession[$NumComm] = "BYE" ;
	# Rarmer le timer (4 cycles) pour cette communication.
	&Listing_addTime($NumComm, 4, $MessageBYE, "/udp/$AdresseClient/$PortClient/") ;
	## Fermeture du client.
	close ($client) ;
	redo ;
    } # Fin du "elsif ($StrctSIPHeader->HLigneEtat->{'Method'} eq 'BYE')"
####    
####
    elsif ($StrctSIPHeader->HLigneEtat->{'Method'} eq 'CANCEL' and $StrctSIPHeader->HLigneEtat->{'Request_URI'} =~ /sip:[^\*].*/) { # Nous sommes en prsence d'un message CANCEL
	print "[DEBUG] pabx.pl, Entre dans la boucle CANCEL\n" ; 
	# Rpondre OK  l'metteur et faire suivre le CANCEL (sauf si faux-numro).
	# Message OK
	
	my $MessageOK = &Packet_messageOK('send', $StrctSIPHeader, $server->peerhost(), $server->peerport()) ;

	## Envoi du message
	$server->send($MessageOK) or die "[ERROR] Erreur lors de l'envoi du MessageOK : $!" ;
	# Message CANCEL
	## Si on est capable de rediriger le flux vers le destinataire, alors modifier la ligne d'tat avec l'adresse IP du destinataire
	if ($TabAdresse{$StrctSIPHeader->HTo->{'To_Num'}}) {
	    ## On connait l'adresse IP du destinataire.
	    $StrctSIPHeader->HLigneEtat->{'LigneEtat'} = 'CANCEL sip:'.$StrctSIPHeader->HTo->{'To_Num'}.'@'.$TabAdresse{$StrctSIPHeader->HTo->{'To_Num'}}.' SIP/2.0' ;
	}

	## Composition du message CANCEL
	my $MessageCANCELHead = '' ;
	if ($TabSession[$NumComm] ne '' && $TabSession[$NumComm] ne "faux_num") { # Si c'est un CANCEL par rapport  une communication en cours et que ce n'est pas un faux-numro (on ne connaitrait pas de correspondant  qui faire suivre le CANCEL).	
#	    my $tailleTab = scalar(@TabVia) ;
#	    (my $Branche) = $TabVia[$tailleTab - 1] =~ /branch=([^;]*)/ ;

# 	    ## Composition du message en 2 fois car on rutilisera tout sauf la ligne d'tat si plusieurs appels sont  clore en mme temps.
# 	    $MessageCANCELHead = "Via: SIP/2.0/UDP $ADRESSESRV:$PORT;branch=$Branche\r
# $StrctSIPHeader->HFrom->{'From'}\r
# $HTo{'To'}\r
# $HCall_ID{'Call_ID'}\r
# $HCSeq{'CSeq'}\r
# $HMax_Forwards{'Max_Forwards'}\r
# $DiversComplet\r
# Content-Length: 0\r
# \r\n" ;
# 	    my $MessageCANCEL = "$HLigneEtat{'LigneEtat'}\r\n".$MessageCANCELHead ;

	    
	    # Composer le message CANCEL  envoyer.
	    my $MessageCANCEL = &Packet_messageCANCEL('send', $StrctSIPHeader, 0, 0) ;

	    ## Crer un autre socket vers le saut suivant
	    my $ProchainSaut = &LCR_Discri($StrctSIPHeader->HFrom->{'From_Num'}, $StrctSIPHeader->HTo->{'To_Num'}) ;
	    my $client = IO::Socket::INET->new( Proto     => 'udp',
						PeerPort  => 5060,
						PeerAddr  => $ProchainSaut) ;
	    die "[ERROR] Impossible de charger le client5 : $!" unless $client ;
	    ## Envoi du message
	    $client->send($MessageCANCEL) if ($client && $ProchainSaut) or die "[ERROR] Erreur lors de l'envoi du MessageCANCEL : $!" ;
	    ## Enregistrement de l'tat de la session et suppression du listing.
	    $TabSession[$NumComm] = "CANCEL" ;
	    # Rarmer le timer (4 cycles) pour cette communication.
	    &Listing_addTime($NumComm, 4, $MessageCANCEL, "/udp/$ProchainSaut/5060/") ;
	    
	    # Fermeture du client.
	    close($client) ;
	    
	} # Fin du "if ($TabSession[$NumComm] ne "faux-num")"
	
	# Si le poste recevant le CANCEL est dans un groupement de poste, alors traitement particulier.
	if ($TabUA{$StrctSIPHeader->HTo->{'To_Num'}}[5] != 0) {
	    for (my $compteur = 10; $compteur < 20; $compteur ++) {
		# Renvoyer le CANCEL seulement pour les postes encore en cours d'appel.
		if ($TabUAFork{$StrctSIPHeader->HTo->{'To_Num'}}[$compteur + 10] == 1) {
		    # Ouvrir socket
		    (my $adresse, my $port) = $TabUAFork{$StrctSIPHeader->HTo->{'To_Num'}}[$compteur] =~ /(\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}):(\d*)/ ;
		    my $client = IO::Socket::INET->new( Proto     => 'udp',
							PeerPort  => $port,
							PeerAddr  => $adresse) ;
		    die "[ERROR] Impossible de charger le client13 : $!" unless $client ;
		    
		    # Envoi du message CANCEL
		    my $MessageCANCEL = 'CANCEL sip:'.$StrctSIPHeader->HTo->{'To_Num'}."\@$adresse:$port SIP/2.0\r\n".$MessageCANCELHead ;
		    $client->send($MessageCANCEL) if ($client && $port && $adresse) or die "[ERROR] Erreur lors de l'envoi du MessageCANCEL (find-me) : $!" ;
		    print "[DEBUG] pabx.pl, CANCEL envoy au $adresse:$port\n" ; 
		    ## Enregistrement de l'tat de la session et suppression du listing.
		    $TabSession[$NumComm] = 'CANCEL' ; 
		    # Rarmer le timer (4 cycles) pour cette communication.
		    &Listing_addTime($NumComm, 4, $MessageCANCEL, "/udp/$adresse/$port") ;
		    # Fermeture du socket
		    close($client) ;

		    # Enregistrement de la fin du suivi.
		    $TabUAFork{$StrctSIPHeader->HTo->{'To_Num'}}[$compteur + 10] = 2 ;
		} # Fin du "if ($TabUAFork{$StrctSIPHeader->HTo->{'To_Num'}}[$compteur] == 1)"
	    } # Fin du "for (my $compteur = 20; $compteur < 30; $compteur ++)"
	} # Fin du "if ($TabUA{"$StrctSIPHeader->HTo->{'To_Num'}}[5] != 0)"

	redo ;
    } # Fin du "elsif ($StrctSIPHeader->HLigneEtat->{'Method'} eq 'CANCEL' and $StrctSIPHeader->HLigneEtat->{'Request_URI'} =~ /sip:[^\*].*/)"
####
####    
    elsif ($StrctSIPHeader->HLigneEtat->{'Status_code'} eq '200' and (($StrctSIPHeader->HCSeq->{'CSeq'} =~ /CANCEL/) or ($StrctSIPHeader->HCSeq->{'CSeq'} =~ /INFO/))) { # Nous sommes en prsence d'un message OK suite  un CANCEL ou  un INFO.
	print "[DEBUG] pabx.pl, Entre dans la boucle OK suite  un CANCEL ou un INFO\n" ; 
	# Ne rien faire.
	# Enregistrement de l'tat de la session.
	$TabSession[$NumComm] = 'OK_'.$StrctSIPHeader->HCSeq->{'CSeq_Type'} ;
	# Chercher dans le listing la communication et la rarmer (devrait suivre un 487).
	&Listing_addTime($NumComm, 4, 0, 0) ;
	# For OK of INFO method, delete the communication.
	&Listing_delComm($NumComm) ; # TEST c'est crade : il faudrait grer le OK de l'INFO  part peut-tre.
	redo ;
    } # Fin du "elsif ($StrctSIPHeader->HLigneEtat->{'Status_code'} eq '200' and ($StrctSIPHeader->HCSeq->{'CSeq'} =~ /CANCEL/ OR $StrctSIPHeader->HCSeq->{'CSeq'} =~ /INFO/))"
####
####
# new ! on pourrait mettre ici tous les 4xx
    elsif ($StrctSIPHeader->HLigneEtat->{'Status_code'} eq '480' or $StrctSIPHeader->HLigneEtat->{'Status_code'} eq '481' or $StrctSIPHeader->HLigneEtat->{'Status_code'} eq '486' or $StrctSIPHeader->HLigneEtat->{'Status_code'} eq '487') { # Nous sommes en prsence d'une rponse 48x
	(my $TypeReq) = $StrctSIPHeader->HLigneEtat->{'Status_code'} =~ /(48\d)/ ;
	print "[DEBUG] pabx.pl, Entre dans la boucle $TypeReq\n" ; 
	# Rpondre avec un message ACK et on fait suivre la requte en enlevant le Via: du haut de la pile.
	my $ProchainSaut = &LCR_Discri($StrctSIPHeader->HFrom->{'From_Num'}, $StrctSIPHeader->HTo->{'To_Num'}) ;
	if ($ProchainSaut ne 'INTERDIT') {
	    
	    my $MessageACK = &Packet_messageACK('send', $StrctSIPHeader, 0, 0,$ProchainSaut) ;

	    ## Envoi du message ACK
	    $server->send($MessageACK) or die "[ERROR] Erreur lors de l'envoi du MessageACK : $!" ;
	} # Fin du "if ($ProchainSaut ne 'INTERDIT')"



	# Si l'appel ne fait pas partie d'une diffusion  un groupement de poste, alors on fait suivre la rponse. Sinon on trace la fin de suivi de cette branche.
	if ($TabUA{$StrctSIPHeader->HTo->{'To_Num'}}[5] == 0) {
	    # Requte Request Terminated
	    ## Recherche de l'adresse  qui faire suivre le Request Terminated (c'est celle indique dans le deuxime Via: en partant du haut de la pile).
	    my $Adresse = '' ;
	    my $Port = '' ;
	    if ($StrctSIPHeader->TabVia->[1] =~ /;received=/) {
		($Adresse) = $StrctSIPHeader->TabVia->[1] =~ /received=(\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3})/ ;
		($Port) = $StrctSIPHeader->TabVia->[1] =~ /rport=(\d*)/ ;
	    }
	    else {
		($Adresse, $Port) = $StrctSIPHeader->TabVia->[1] =~ /Via: SIP\/2\.0\/(?:UDP|TCP|SCTP) (\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}):?(\d*)?.*/ ;
	    }
	    ## Composition du paragraphe Via: : on crit tous les Via: sauf celui du haut de la pile.
	    my $ParaVia = &Packet_viaCompose('suppr', $StrctSIPHeader->TabVia, 0, 0) ;

	    my $Message48x = &Packet_message4xx('forward', $StrctSIPHeader, 0, 0, $StrctSIPHeader->HLigneEtat->{'LigneEtat'}) ;

# 	    ## Composition de la requte 48x
# 	    my $Message48x = "$HLigneEtat{'LigneEtat'}\r
# $ParaVia\r
# $StrctSIPHeader->HFrom->{'From'}\r
# $HTo{'To'}\r
# $HCall_ID{'Call_ID'}\r
# $HCSeq{'CSeq'}\r
# $DiversComplet\r
# Content-Length: 0\r
# \r\n" ;
	    
	    ## Crer un autre socket vers le saut suivant ssi une adresse de destination est dfinie.
	    if ($Adresse) {
		# Si aucun port n'est indiqu, on utilise le port par dfaut qui est le 5060.
		if (!$Port) {$Port = 5060 ;}
		my $client = IO::Socket::INET->new( Proto     => 'udp',
						    PeerPort  => $Port,
						    PeerAddr  => $Adresse) ;
		die "[ERROR] Impossible de charger le client7 : $!" unless $client ;
		## Envoi du message
		$client->send($Message48x) if ($client && $Port && $Adresse) or die "[ERROR] Erreur lors de l'envoi du Message48x : $!" ;
		
		## Enregistrement de l'tat de la session.
		$TabSession[$NumComm] = "$TypeReq" ;
		# Rarmer le timer (4 cycles) pour cette communication.
		&Listing_addTime($NumComm, 4, $Message48x, "/udp/$Adresse/$Port/") ;
		## Fermeture du client.
		close($client) ;
	    }
	} # Fin du "if ($TabUA{$StrctSIPHeader->HTo->{'To_Num'}}[5] == 0)"
	else {
	    # Parcourir la liste des appels li au numro pour trouver celui  quelle branche appartient le 48x reu.
	    for (my $compteur = 10; $compteur < 20; $compteur ++) {
		if ($TabUAFork{$StrctSIPHeader->HTo->{'To_Num'}}[$compteur] eq ''.$server->peerhost().":".$server->peerport().'') {
		    $TabUAFork{$StrctSIPHeader->HTo->{'To_Num'}}[$compteur + 10] = 2 ;
		}
	    }
	    # Enregistrement de l'tat de la session seulement s'il n'y a pas de postes du groupement plus en avance que trying.
	    if ($TabSession[$NumComm] eq 'Trying') {
		$TabSession[$NumComm] = "$TypeReq" ;
	    }
	} # Fin du "else"
	
	redo ;
    } # Fin du "elsif ($StrctSIPHeader->HLigneEtat->{'Status_code'} eq '480' or $StrctSIPHeader->HLigneEtat->{'Status_code'} eq '481' or $StrctSIPHeader->HLigneEtat->{'Status_code'} eq '486' or $StrctSIPHeader->HLigneEtat->{'Status_code'} eq '487')"
####
####
    # Ne pas propager les ACK des 4xx, tout simplement
    elsif ($StrctSIPHeader->HLigneEtat->{'Method'} eq 'ACK' and ($TabSession[$NumComm] eq 'OK_CANCEL' or $TabSession[$NumComm] =~ /40[1467]/ or $TabSession[$NumComm] =~ /48[067]/ or $TabSession[$NumComm] =~ /302_\w*/ or $StrctSIPHeader->HLigneEtat->{'Request_URI'} =~ /sip:\*/)) { # Nous sommes en prsence d'un message ACK suite  un OK d'un 401/404/480/486/487 ou d'un 302
	print "[DEBUG] pabx.pl, Entre dans la boucle ACK suite  OK/302/401/404/406/407/480/486/487 : $TabSession[$NumComm]\n" ; 
	# On ne fait rien.
	# Enregistrement de l'tat de la session.
	$TabSession[$NumComm] = 'ACK_'.$TabSession[$NumComm] ;
	# Chercher dans le listing la communication et la supprimer sauf pour les requtes d'auth (401 et 407).
	if ($TabSession[$NumComm] !~ /407/) {
	    &Listing_delComm($NumComm) ;
	    delete($TabSession[$NumComm]) ;
	}
	redo ;
    } # Fin du "elsif ($StrctSIPHeader->HLigneEtat->{'Method'} eq 'ACK' and ($TabSession[$NumComm] eq "OK_CANCEL" or $TabSession[$NumComm] =~ /40[147]/ or $TabSession[$NumComm] =~ /48[067]/ or $TabSession[$NumComm] =~ /302_\w*/ or $StrctSIPHeader->HLigneEtat->{'Request_URI'} =~ /sip:\*/))"
####
####
    elsif ($StrctSIPHeader->HLigneEtat->{'Method'} eq 'INFO') { # Nous sommes en prsence d'un message INFO
	print "[DEBUG] pabx.pl, Entre dans la boucle INFO\n" ; 
	# TEST : A CODER
	# Notre proxy SIP ne gre pas lui-mme le contenu des messages SIP mme si la norme autorise ce cas.
	# RFC 2976 : paragraphe 2.2
	# Si la session existe, rpondre OK (sans le corps) et faire suivre le INFO en se rajoutant dans le Via:, sinon, rpondre 481 Call Leg/Transaction Does Not Exist et ne rien faire suivre.
	if ($TabSession[$NumComm] =~ /OK/) {
	    # Send a OK.
	    
	    my $MessageOK = &Packet_messageOK('send', $StrctSIPHeader, $server->peerhost(), $server->peerport()) ;

	    ## Send the OK message.
	    $server->send($MessageOK) or die "[ERROR] Erreur lors de l'envoi du MessageOK : $!" ;

	    ## Forward the INFO message.
	    ## Compose the INFO message.
	    ## Add myself on the Via: paragraph.
	    my $ParaVia = &Packet_viaCompose('ajout', $StrctSIPHeader->TabVia, $server->peerhost(), $server->peerport()) ; 
	    
	    my $MessageINFO = $StrctSIPHeader->HLigneEtat->{'LigneEtat'}."\r
$ParaVia\r
".$StrctSIPHeader->HFrom->{'From'}."\r
".$StrctSIPHeader->HTo->{'To'}."\r
".$StrctSIPHeader->HCall_ID->{'Call_ID'}."\r
".$StrctSIPHeader->HCSeq->{'CSeq'}."\r
".$StrctSIPHeader->DiversComplet."\r
".$StrctSIPHeader->Content_Length."\r
\r
".$StrctSIPHeader->CorpsMessage ;
	    
	    ## Find the address which to send the message and send it.
	    (my $nextAdr) = $StrctSIPHeader->HLigneEtat->{'Request_URI'} =~ /.*\@([^\s|^;]*).*/ ;

	    my $client = IO::Socket::INET->new( Proto     => 'udp',
						PeerPort  => 5060,
						PeerAddr  => $nextAdr) ;
	    die "[ERROR] Impossible de charger le client8 : $!" unless $client ;
	    $client->send($MessageINFO) if ($client && $nextAdr) or die "[ERROR] Erreur lors de l'envoi du MessageINFO : $!" ;

#	    print "$TabSession[$NumComm] = INVITE_INFO\n" ;
	}
	else {
	    # Send a 481 Call Leg/Transaction Does Not Exist.
	}
	redo ;
    } # Fin du "elsif ($StrctSIPHeader->HLigneEtat->{'Method'} eq 'INFO')"
####
####
    elsif ($StrctSIPHeader->HLigneEtat->{'Status_code'} eq '302') { # Nous sommes en prsence d'un message Moved Temporarily.
	print "[DEBUG] pabx.pl, Entre dans la boucle 302\n" ; 
	my $RaisonDiversion = $StrctSIPHeader->HLigneEtat->{'Reason_phrase'} ;
	# Pas de traitement si nous sommes dans un groupement de postes.
	if ($TabUA{$StrctSIPHeader->HTo->{'To_Num'}}[5] == 0) {

	    # On rpond par un ACK. Changer le CSeq. Changer les Via:.
	    # On fait suivre la rponse 302 au second Via: : on ne garde pour le ACK que le premier Via: avec ventuellement branch=.
	    # Message ACK
	    ## Composition du paragraphe Via:
	    (my $ParaViaPart1, my $ParaViaPart2) = $StrctSIPHeader->TabVia->[0] =~ /([^;]*).*(;branch=[^;]*).*/ ;
	    my $ParaVia = $ParaViaPart1.$ParaViaPart2 ;

	    my $MessageACK = &Packet_messageACK('send', $StrctSIPHeader, 0, 0, $StrctSIPHeader->HTo->{'To_AdrIP'}) ;

	    ## Envoi du message
	    $server->send($MessageACK) or die "[ERROR] Erreur lors de l'envoi du MessageACK : $!" ;

	    # Rponse 302.
	    ## Recherche de l'adresse  qui faire suivre le Request Terminated (c'est celle indique dans le deuxime Via: en partant du haut de la pile).
	    my $Adresse = '' ;
	    my $Port = '' ;
	    if ($StrctSIPHeader->TabVia->[1] =~ /;received=/) {
		($Adresse) = $StrctSIPHeader->TabVia->[1] =~ /received=(\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3})/ ;
		($Port) = $StrctSIPHeader->TabVia->[1] =~ /rport=(\d*)/ ;
	    }
	    else {
		($Adresse, $Port) = $StrctSIPHeader->TabVia->[1] =~ /Via: SIP\/2\.0\/(?:UDP|TCP|SCTP) (\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}):?(\d*)?.*/ ;
	    }
# 	    ## Composition du paragraphe Via: : on crit tous les Via: sauf celui du haut de la pile
# 	    $ParaVia = &Packet_viaCompose("suppr", $StrctSIPHeader->TabVia, 0, 0) ;
# 	    ## Composition du message.
# 	    my $MessageMovedTemporarily = "$HLigneEtat{'LigneEtat'}\r
# $ParaVia\r
# $StrctSIPHeader->HFrom->{'From'}\r
# $HTo{'To'}\r
# $HCall_ID{'Call_ID'}\r
# $HCSeq{'CSeq'}\r
# $DiversComplet\r
# Content-Length: 0\r
# \r\n" ;
	    
	    my $MessageMovedTemporarily = &Packet_message3xx('forward', $StrctSIPHeader, 0, 0, 'SIP/2.0 302 Moved Temporarily') ;

	    ## Crer un autre socket vers le saut suivant
	    # Si aucun port n'est indiqu, on utilise le port par dfaut qui est le 5060.
	    if (!$Port) {$Port = 5060 ;}
	    my $client = IO::Socket::INET->new( Proto     => 'udp',
						PeerPort  => $Port,
						PeerAddr  => $Adresse) ;
	    die "[ERROR] Impossible de charger le client9 : $!" unless $client ;
	    ## Envoi du message
	    $client->send($MessageMovedTemporarily) if ($client && $Port && $Adresse) or die "[ERROR] Erreur lors de l'envoi du MessageMovedTemporarily : $!" ;
	    # Enregistrement de l'tat de la session.
	    $TabSession[$NumComm] = "302_$RaisonDiversion" ;
	    # Rarmer le timer (4 cycles) pour cette communication.
	    &Listing_addTime($NumComm, 4, $MessageMovedTemporarily, "/udp/$Adresse/$Port") ;
	    # Fermeture du client.
	    close($client) ;
	} # Fin du "if ($TabUA{$StrctSIPHeader->HTo->{'To_Num'}}[5] == 0)"
	redo ;
    } # Fin du "elsif ($StrctSIPHeader->HLigneEtat->{'Status_code'} eq '302')"
####
####
    elsif ((my $ReferAdr, my $ReferPort) = $StrctSIPHeader->HLigneEtat->{'LigneEtat'} =~ /REFER sip:.*\@(\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}):?(\d*)?(?:;.*)* SIP\/2\.0/) { # Nous sommes en prsence d'un message REFER.
	print "[DEBUG] pabx.pl, Entre dans la boucle REFER\n" ; 
	# On fait suivre en se rajoutant dans les Via:. On fait suivre  l'adresse qui est indique dans la ligne d'tat.
# 	# Composition du paragraphe Via: : on rajoute received= dans Via: de tte et on se rajoute en haut de la pile avec une branch=.
# 	my $ParaVia = &Packet_viaCompose('ajout', $StrctSIPHeader->TabVia, $server->peerhost(), $server->peerport()) ;
# 	## On garde le paragraphe Route: comme il est.
# 	my $ParaRoute = join("\r\n", @TabRoute) ;
# 	## Enlever 1 au Max-Forwards.
# 	$HMax_Forwards{'Max_Forwards_Valeur'} = "Max-Forwards: ".($HMax_Forwards{'Max_Forwards_Valeur'} - 1) ;
# 	## Composition du message
# #$ParaRoute\r
# 	my $MessageREFER = "$HLigneEtat{'LigneEtat'}\r
# $ParaVia\r
# $StrctSIPHeader->HFrom->{'From'}\r
# $HTo{'To'}\r
# $HCall_ID{'Call_ID'}\r
# $HCSeq{'CSeq'}\r
# $HMax_Forwards{'Max_Forwards_Valeur'}\r
# $DiversComplet\r
# Content-Length: 0\r
# \r\n" ;

	my $MessageREFER = &Packet_messageREFER('forward', $StrctSIPHeader, $server->peerhost(), $server->peerport(),) ;
	
	# Crer un socket vers le saut suivant
	# Si aucun port n'est indiqu, on utilise le port par dfaut qui est le 5060.
	if (!$ReferPort) {$ReferPort = 5060 ;}
	
	my $client = IO::Socket::INET->new( Proto     => 'udp',
					    PeerPort  => $ReferPort,
					    PeerAddr  => $ReferAdr) ;
	die "[ERROR] Impossible de charger le client10 : $!" unless $client ;

	## Envoi de la rponse
	$client->send($MessageREFER) if ($client && $ReferPort && $ReferAdr) or die "[ERROR] Erreur lors de l'envoi du MessageREFER : $!" ;
	## Enregistrement de l'tat de la session.
	$TabSession[$NumComm] = 'REFER' ;
	# Rarmer le timer (4 cycles) pour cette communication.
	&Listing_addTime($NumComm, 4, $MessageREFER, "/udp/$ReferAdr/$ReferPort/") ;
	## Fermeture du client.
	close ($client) ;
	redo ;
    } # Fin du "elsif (($ReferAdr) = $StrctSIPHeader->HLigneEtat->{'LigneEtat'} =~ /REFER sip:.*\@(\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3})(?:;.*|) SIP\/2\.0/)"
####
####
    elsif ($StrctSIPHeader->HLigneEtat->{'Status_code'} eq '202') { # Nous sommes en prsence d'une rponse 202 Accepted (donc suite  REFER)
	print "[DEBUG] pabx.pl, Entre dans la boucle 202 Accepted\n" ; 
	# 13.2.2.4, RFC 3261 : The UAC core MUST generate an ACK request for each 2xx received from the transaction layer. The header fields of the ACK are constructed in the same way as for any request sent within a dialog (see Section 12) with the exception of the CSeq and the header fields related to authentication. The sequence number of the CSeq header field MUST be the same as the INVITE being acknowledged, but the CSeq method MUST be ACK. The ACK MUST contain the same credentials as the INVITE. If the 2xx contains an offer (based on the rules above), the ACK MUST carry an answer in its body. If the offer in the 2xx response is not acceptable, the UAC core MUST generate a valid answer in the ACK and then send a BYE immediately.

	# Enlever le Via: du haut de la pile et faire suivre au Via: suivant auquel on aura enlev les paramtres sauf branch=.
	## Trouver l'adresse du prochain destinataire.
	my $Adresse = '' ;
	my $Port = '' ;
	if ($StrctSIPHeader->TabVia->[1] =~ /;received=/) {
	    ($Adresse) = $StrctSIPHeader->TabVia->[1] =~ /received=(\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3})/ ;
	    ($Port) = $StrctSIPHeader->TabVia->[1] =~ /rport=(\d*)/ ;
	}
	else {
	    ($Adresse, $Port) = $StrctSIPHeader->TabVia->[1] =~ /Via: SIP\/2\.0\/(?:UDP|TCP|SCTP) (\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}):?(\d*)?.*/ ;
	}


	my $MessageAccepted = &Packet_messageAccepted('forward', $StrctSIPHeader, 0, 0) ;

#	## Composition du paragraphe Via: : on ne garde que le premier Via: avec branch= si ce dernier est indiqu.
#	shift(@TabVia) ;
#	(my $ParaViaPart1, my $ParaViaPart2) = $TabVia[0] =~ /([^;]*).*(;branch=[^;]*).*/ ;

	
	
#	my $ParaVia = join("\r\n", @TabVia) ;
# 	# Composition de la rponse
# 	my $MessageAccepted = "$HLigneEtat{'LigneEtat'}\r
# $ParaVia\r
# $StrctSIPHeader->HFrom->{'From'}\r
# $HTo{'To'}\r
# $HCall_ID{'Call_ID'}\r
# $HCSeq{'CSeq'}\r
# $DiversComplet\r
# Content-Length: 0\r
# \r\n" ;
	
	# Si aucun port n'est indiqu, on utilise le port par dfaut qui est le 5060.
	if (!$Port) {$Port = 5060 ;}
	my $client = IO::Socket::INET->new( Proto     => 'udp',
					    PeerPort  => $Port,
					    PeerAddr  => $Adresse) ;
	die "[ERROR] Impossible de charger le client11 : $!" unless $client ;
	## Envoi de la rponse
	$client->send($MessageAccepted) if ($client && $Port && $Adresse) or die "[ERROR] Erreur lors de l'envoi du MessageAccepted : $!" ;
	## Enregistrement de l'tat de la session.
	$TabSession[$NumComm] = "REFER_202" ;
	# Rarmer le timer (4 cycles) pour cette communication.
	&Listing_addTime($NumComm, 4, 0, 0) ;
	## Fermeture du client.
	close ($client) ;
    	redo ;
    } # Fin du "elsif ($StrctSIPHeader->HLigneEtat->{'Status_code'} eq '202')"
####
####
    elsif ($StrctSIPHeader->HLigneEtat->{'Method'} eq 'INVITE' and ((my $Prefixe) = $StrctSIPHeader->HLigneEtat->{'Request_URI'} =~ /sip:(\*\d*)\@.*/)) { # Nous sommes en prsence d'un message INVITE avec un prefixe
	print "[DEBUG] pabx.pl, Entre dans la boucle INVITE prfixe ($Prefixe)\n" ; 
	# Traitement en fonction du prfixe.
	my $Numero = 0 ;
	## Ce prfixe est pour annuler un numro supplmentaire sur le poste
	if (($Numero) = $Prefixe =~ /.$NOADDNUM(\d*)/) {
	    $TabAdresse{$Numero} = '' ;
	}
	## Ce prfixe est pour dclarer un numro supplmentaire sur le poste
	if (($Numero) = $Prefixe =~ /.$ADDNUM(\d*)/) {
	    $TabAdresse{$Numero} = $TabAdresse{$StrctSIPHeader->HFrom->{'From_Num'}} ;
	}
	## Ce prfixe est pour annuler un renvoi inconditionnel vers un autre poste depuis le proxy
	if (($Numero) = $Prefixe =~ /.$NORENVINC(\d*)/) {
	    ## On remet l'ancienne adresse IP pour annuler le renvoi.
	    $TabAdresse{$StrctSIPHeader->HFrom->{'From_Num'}} = $TabUA{$StrctSIPHeader->HFrom->{'From_Num'}}[21] ;
	    ## On nettoie la case du tableau relative au renvoi.
	    $TabUA{$StrctSIPHeader->HFrom->{'From_Num'}}[21] = '' ;
	}
	# Ce prfixe est pour faire un renvoi inconditionnel vers un autre poste depuis le proxy
	if (($Numero) = $Prefixe =~ /.$RENVINC(\d*)/) {
	    ## On stocke l'actuelle adresse IP dans le tableau. Utile pour l'annulation du renvoi.
	    $TabUA{$StrctSIPHeader->HFrom->{'From_Num'}}[21] = $TabAdresse{$StrctSIPHeader->HFrom->{'From_Num'}} ; 
	    $TabAdresse{$StrctSIPHeader->HFrom->{'From_Num'}} = $TabAdresse{$Numero} ;
	}
# ADD CODE HERE ... if we want other functionalities.

	# On retourne un Ringing pour indiquer la prise en compte du prfixe.

	my $MessageRinging = &Packet_messageRinging('send', $StrctSIPHeader, $server->peerhost(), $server->peerport()) ;

	## Envoi de la rponse
	$server->send($MessageRinging) or die "[ERROR] Erreur lors de l'envoi du MessageRinging : $!" ;
	redo ;
    } # Fin du "elsif ($StrctSIPHeader->HLigneEtat->{'Method'} eq 'INVITE' and ((my $Prefixe) = $StrctSIPHeader->HLigneEtat->{'Request_URI'} =~ /sip:(\*\d*)\@.*/))"
####
####
    elsif ($StrctSIPHeader->HLigneEtat->{'Method'} eq 'CANCEL' and $StrctSIPHeader->HLigneEtat->{'Request_URI'} =~ /sip:\*.*/) { # Nous sommes en prsence d'un message CANCEL suite  une session ouverte par un prfixe
	print "[DEBUG] pabx.pl, Entre dans la boucle CANCEL prfixe\n" ; 
	# Rpondre OK.

	my $MessageOK = &Packet_messageOK('send', $StrctSIPHeader, $server->peerhost(), $server->peerport()) ;

	## Envoi du message
	$server->send($MessageOK) or die "[ERROR] Erreur lors de l'envoi du MessageOK : $!" ;
	# Enregistrement de l'tat de la session.
	$TabSession[$NumComm] = 'OK_CANCEL' ;
	redo ;
    } # Fin du "elsif ($StrctSIPHeader->HLigneEtat->{'Method'} eq 'CANCEL' and $StrctSIPHeader->HLigneEtat->{'Request_URI'} =~ /sip:\*.*/)"
####
####
    elsif ((my $TypeRep) = $StrctSIPHeader->HLigneEtat->{'Status_code'} =~ /(60\d)/) { # Nous sommes en prsence d'une rponse 60x (code de dfaillance gnrale).
	print "[DEBUG] pabx.pl, Entre dans la boucle 60x : $TypeRep\n" ; 
	# Enlever le Via: du haut de la pile et faire suivre au Via: suivant auquel on ne garde que l'ventuelle branch=.
	## Recherche de l'adresse  qui faire suivre le Request Terminated (c'est celle indique dans le deuxime Via: en partant du haut de la pile).
	my $Adresse = '' ;
	my $Port = '' ;
	if ($StrctSIPHeader->TabVia->[1] =~ /;received=/) {
	    ($Adresse) = $StrctSIPHeader->TabVia->[1] =~ /received=(\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3})/ ;
	    ($Port) = $StrctSIPHeader->TabVia->[1] =~ /rport=(\d*)/ ;
	}
	else {
	    ($Adresse, $Port) = $StrctSIPHeader->TabVia->[1] =~ /Via: SIP\/2\.0\/(?:UDP|TCP|SCTP) (\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}):?(\d*)?.*/ ;
	}
	## Composition du paragraphe Via: : on ne garde que le premier Via: et le branch= si ce dernier est indiqu.
#	shift(@{$StrctSIPHeader->TabVia}) ;
#	(my $ParaViaPart1, my $ParaViaPart2) = $StrctSIPHeader->TabVia->[0] =~ /([^;]*).*(;branch=[^;]*).*/ ;
#	my $ParaVia = join("\r\n", @{$StrctSIPHeader->TabVia}) ;
	# Composition du Record-Route : on rajoute le serveur pour qu'il soit sur la route (sauf s'il y est dj).
	if (grep(/$ADRESSESRV/, @{$StrctSIPHeader->TabRRoute}) == 0) {
	    unshift(@{$StrctSIPHeader->TabRRoute}, "Record-Route: <sip:$ADRESSESRV;lr>") ;
	}
#	my $ParaRRoute = join("\r\n", @{$StrctSIPHeader->TabRRoute}) ;
	
	my $Message60x = &Packet_message6xx('forward', $StrctSIPHeader, 0, 0, $StrctSIPHeader->HLigneEtat->{'LigneEtat'}) ;

# 	# Composition de la rponse
# 	my $Message60x = "$HLigneEtat{'LigneEtat'}\r
# $ParaVia\r
# $StrctSIPHeader->HFrom->{'From'}\r
# $HTo{'To'}\r
# $HCall_ID{'Call_ID'}\r
# $ParaRRoute\r
# $HCSeq{'CSeq'}\r
# $DiversComplet\r
# Content-Length: 0\r
# \r\n" ;
	# Si aucun port n'est indiqu, on utilise le port par dfaut qui est le 5060.
	if (!$Port) {$Port = 5060 ;}
	my $client = IO::Socket::INET->new( Proto     => 'udp',
					    PeerPort  => $Port,
					    PeerAddr  => $Adresse) ;
	die "[ERROR] Impossible de charger le client15 : $!" unless $client ;
	## Envoi de la rponse
	$client->send($Message60x) if ($client && $Port && $Adresse) or die "[ERROR] Erreur lors de l'envoi du MessageDecline : $!" ;
	## Enregistrement de l'tat de la session.
	$TabSession[$NumComm] = $TypeRep ;
	# Rarmer le timer (4 cycles) pour cette communication.
	&Listing_addTime($NumComm, 4, $Message60x, "/udp/$Adresse/$Port/") ;
	## Fermeture du client et du serveur.
	close ($client) ;

	redo ;
    } # Fin du elsif "(($TypeRep) = $StrctSIPHeader->HLigneEtat->{'Status_code'} =~ /(60\d)\s/)"
    ####################################################
    # Le paquet n'a pu tre trait car format inconnu.
    print "[WARN ] Paquet non reconnu donc ignor.\n" ;
#    print "[DEBUG] Paquet non reconnu : $TabSession[$NumComm]\n".$StrctSIPHeader->HLigneEtat->{'LigneEtat'}.' et '.$StrctSIPHeader->HCall_ID->{'Call_ID_ID'}.' et '.$StrctSIPHeader->HCSeq->{'CSeq'}\n" ;

    # TODO : 8.2.1 : RFC 3261 : If the UAS recognizes but does not support the method of a request, it MUST generate a 405 (Method Not Allowed) response.[...] The UAS MUST also add an Allow header field to the 405 (Method Not Allowed) response.


    &Listing_delComm($NumComm) ;    
} # Fin du "while (1)"


# Fermeture du serveur.
close ($server) ;
