#!/usr/bin/perl

#####################################################
#                 GESTION MVo                      #
# AUTEUR : Guillaume Lehmann                        #
# Pour tout renseignement, lehmann@free.fr          #
# Ce logiciel est sous licence GPL v3               #
# v 0.1 du 09/09/2007                               #
# v 0.2 du 17/09/2007                               #
# v 0.3 du 18/09/2007                               #
# v 0.4 du 20/09/2007                               #
# v 0.5 du 24/09/2007                               #
# v 0.6 du 20/10/2007                               #
# v 0.7 du 10/11/2007                               #
# v 0.8 du 29/11/2007                               #
# v 0.9 du 01/12/2007                               #
# v 0.10 du 02/12/2007                              #
# v 0.11 du 08/12/2007                              #
# v 0.12 du 09/12/2007                              #
# v 0.13 du 20/01/2008                              #
# v 0.14 du 15/04/2008                              #
# v 0.15 du 07/06/2008                              #
# v 0.16 du 08/06/2008                              #
# v 0.17 du 06/07/2008                              #
# v 0.18 du 20/03/2010                              #
#####################################################




use IO::Socket::INET ;

require "config.pl" ;
require "pabxFct.pl" ;

# Pour ne pas avoir  faire un wait  la mort d'un processus fils sans avoir peur de crer un zombie.
$SIG{'CHLD'} = 'IGNORE' ;

print "[Serveur $0 charg [PID : $$] [UID : $<] [OS : $^O] !]\n" ;

print "[==> Service prt ! <==]\n\n" ;

# Initialize variables.
my $NbTour = 0 ;
my $LigneFichier = "" ;
my $Num = 0 ;
my $MessageNew = 0 ;
my $MessageOld = 0 ;
my $MessageNewURG = 0 ;
my $MessageOldURG = 0 ;
my $EtatGlobal = "" ;
my %TabEtatGlobal = () ;

while (1) {
    # Attente avant de revrifier l'tat de messagerie.
    sleep (10) ;

    # Refaire une annonce si cela fait plusieurs tours que nous n'en avons pas faite.
    $NbTour ++ ;
    if ($NbTour == 6) {
	$NbTour = 0 ;
    }

    # Pour chaque ligne du fichier MeVo, on regarde s'il faut envoyer un NOTIFY.
    open (FICHIERMEVO, "MeVo") ;
    while ($LigneFichier = <FICHIERMEVO>) {
	($Num, $MessageNew, $MessageOld, $MessageNewURG, $MessageOldURG) = $LigneFichier =~ /^(\w*)\s(\d*)\s(\d*)\s(\d*)\s(\d*)/ ;

	$EtatGlobal = "no" ;
	if ($MessageNew != 0) {
	    $EtatGlobal = "yes" ;
	}
	
	# On n'envoie le NOTIFY que si on a un changement d'tat ou que ce numro n'a pas encore t enregistr (vide) ou que cela fait un moment que l'on n'a rien envoy.
	if ($TabEtatGlobal{$Num} ne $EtatGlobal || $TabEtatGlobal{$Num} eq "" || $NbTour == 0) {
	    # Enregistrer le nouvel tat.
	    $TabEtatGlobal{$Num} = $EtatGlobal ;
	    
	    ####################################################
	    # Composition du message NOTIFY
	    my $NouvelleBranche = Packet_compoTagBranchNum("b") ;
	    my $NouvelleSeq = Packet_compoTagBranchNum("n") ;
	    # Gnrer le corps du message indiquant l'tat de la MVo pour ce compte et en calculer la longueur pour le Content-Length:.
	    $EtatMessagerie = "Messages-Waiting: $EtatGlobal\r\nMessage-Account: sip:$Num\@$TabAdresse{$Num}\r\nVoice-Message: $MessageNew/$MessageOld ($MessageNewURG/$MessageOldURG)\r\n" ;
	    $Content_Length_Val = length($EtatMessagerie) ;
	    $MessageNOTIFY = "NOTIFY sip:$Num\@$TabAdresse{$Num} SIP/2.0\r
Via: SIP/2.0/UDP $ADRESSESRV:$PORT;branch=$NouvelleBranche\r
From: <sip:$Num\@$ADRESSESRV>\r
To: <sip:$Num\@$TabAdresse{$Num}\r
Call-ID : $NouvelleBranche\r
CSeq: $NouvelleSeq NOTIFY\r
Contact: <sip:$Num\@$ADRESSESRV>
Event: message-summary\r
Subscription-State: active\r
Content-Type: application/simple-message-summary\r
Content-Length: $Content_Length_Val\r
\r
$EtatMessagerie\r" ;

	    # Envoi du message aprs cration d'un socket
 	    my $client = IO::Socket::INET->new( Proto     => 'udp',
						PeerPort  => $PORT,
						PeerAddr  => $TabAdresse{$Num}) ;
	    warn "[ERROR] Impossible de charger le client1 : $!" unless $client ;
	    ## Envoi de la rponse
	    $client->send($MessageNOTIFY) or die "[FATAL] Erreur lors de l'envoi du MessageNOTIFY : $!" ;
	    print "Envoi d'une notification pour le $Num : $MessageNew/$MessageOld ($MessageNewURG/$MessageOldURG)\n" ;
	    # Fermeture du serveur
	    close ($client) ;
	} # Fin du "if ($TabEtatGlobal{$Num} != "no" OR $EtatGlobal != "no")"
    } # Fin du  "while ($LigneFichier = <FICHIERMEVO>)"
    close (FICHIERMEVO) ;
    
    ####################################################
    
} # Fin du "while (1)"
